// ------------------------------------------------------------------------
// Programa ..: DBMANT.PRG
//
// Descripcin: Funcoes para a manutencao geral dos registros.
//
// Autor .....: Aulaware - A. Canudas
//
// Funciones    Comentario alterado por Joao em 12/04/2002 a meu criterio
// ------------ -----------------------------------------------------------
// IsNot        Comprueba en las altas que no dupliquemos registros.
// ApagarCli    Apagar o registro selecionado no LISTBOX.
// GetNewAlias  Asigna un nombre de alias a una tabla que no exista ya.
// GetIndices   Obtiene los nombres de los ndices (TAGs).
// PictPts      Picture para valores en Pts.
// PictEuros    Picture para valores en Euros.
// Num2StrDec   Transforma un valor numrico en cadena formateada.
// Num2Str      Transforma un valor numrico en cadena formateada.
// Num2Doc      Transforma un valor numrico en cadena formateada.
// IsPar        Comprueba si un n es par o no (para los colores browse)
//
// Data         Comentario
// ------------ -----------------------------------------------------------
// Maio, 2000   Algunas funciones no son utilizadas.
// ------------------------------------------------------------------------

#Include "FiveWin.Ch"
#Include "Directry.Ch"

#Define SW_NORMAL              1
#Define SW_MAXIMIZE            3
#Define SW_MINIMIZE            6
#Define SW_RESTORE             9

// Para Que a Tecla de Funo dentro dos mdulos
//No Se Acionem + de 1 vez, Engano o Clipper...(Compilador)
Static lAtivo := .F. // By Ednaldo Rolim The Best... Muito Bom.

// -----------------------------------------------------------------------
// Funcin ...: IsNot
// Descripcin: Comprueba en las altas que el cdigo indicado no exista.
// Par metros : cCodigo   -> Clave indice.
// Devolve ..: lDevuelve -> .F. o .T. segn exista o no.
// -----------------------------------------------------------------------
FUNCTION IsNot( cCodigo )

   LOCAL lDevuelve := .T.

   DbSetOrder( 1 )
   DbSeek( cCodigo )

   IF Found()
      MsgStop( OemToAnsi( "Este Cdigo: " + AllTrim( cCodigo ) + " Ja existe." ) )
      lDevuelve := .F.
   ENDIF

RETURN lDevuelve

Function Achou(Campo)
  
    If Empty(CAMPO)

        SndPlaySound(".\Erro.wav" )

        MsgStop ("Por Favor!!                     " + CRLF + ;
						      CRLF + ;
                 "Para Localizar, Digite Matrcula" + CRLF + ;
                 "(Cdigo) ou o Nome a Procurar!  " + CRLF + ;
                 "Tente de Novo, Preencha o Campo!",         ;
                 "Ateno!!")

        SndPlaySound(".\Lembrete.wav" )

    Endif

Return(empty(Campo))

Function Vazio(Campo)

    If empty(CAMPO)

        SndPlaySound(".\Erro.wav" )

        MsgStop("Por Favor!!"        + CRLF + CRLF  +        ;
                "Este Campo Deve Ser Preenchido   " + CRLF + ;
                "Tome Todo o Cuidado, Possivel!!! " + CRLF + ;
                "E R R O !  E R R O !   E R R O ! ",         ;
                "Ateno!!")

        SndPlaySound(".\Lembrete.wav" )

    Endif

return(empty(Campo))

Function Vazio2(Campo)

    If empty(CAMPO)

        SndPlaySound(".\Erro.wav" )

        MsgStop("Cuidado!!  "        + CRLF + CRLF    +        ;
                "Operao Ilegal, Voc Est Tentando" + CRLF + ;
                "Gravar os Dados, Mas No Preencheu " + CRLF + ;
                "Todos os Campos Necessrios..      " + CRLF + ;
                "Por Favor, Tente de Novo...Preencha",         ;
                "Ateno!!")

        SndPlaySound(".\Lembrete.wav" )

    Endif

return(empty(Campo))

Function Vazio3(Campo)

    If empty(CAMPO)

        SndPlaySound(".\Erro.wav" )

        MsgStop( "Banco de Dados Vazio!!!  " + CRLF + ;
                 "Digite o Pedido Antes.   " + CRLF + ;
                 "Click No Campo Correto.  " + CRLF + ;
                 "Se Errar, Tente de Novo!!",         ;
                 "Por Favor, Pare!!!" )

        SndPlaySound(".\Lembrete.wav" )

    Endif

return(empty(Campo))

FUNCTION Existe( cCodigo )

   field Codigo
   field Raz_matric
   Local oDbf
   LOCAL lDevuelve := .T.

   dbSetOrder( 1 )
   dbSeek( cCodigo )
   IF Found()

       SndPlaySound(".\Erro.wav" )

       MsgStop( "Esta Matrcula J  Existe,  No  Insista.  Perigo!!!"+ CRLF + ;
                "Voc S Pode Alterar os Campos Abaixo  da  Matrcula"+ CRLF + ;
                "Use <Esc> Para Sair, Retorne e Clique No Campo Certo"+ CRLF + ;
                "Se Errar, Use Opo <Cancelar> ou <Esc> Para Abortar",        ;
                "Por Favor, Pare!!!" )
       lDevuelve := .F.

        SndPlaySound(".\Lembrete.wav" )

   ENDIF

   IF ( cCodigo ) # (Raz_matric)

       SndPlaySound(".\Erro.wav" )

       MsgStop( "Ateno: Sr. Operador, Voc Est Tentado Uma Operao Ilegal."+ CRLF + ;
                "Este Cliente J Tem Uma Matrcula Definida Anteriormente,  Se"+ CRLF + ;
                "Realmente Deseja Mudar Esta Matrcula,  Troque-a  e  Confirme"+ CRLF + ;
                "Com a Tecla <Aceitar> Somente se Tiver Plena Certeza.  PARE!!"+ CRLF + ;
                "Obs.:  de Sua Inteira Responsabilidade Eventuais  Danos Cau-"+ CRLF + ;
                "sados aos Demais Bancos de Dados, Pois Todos os Demais Bancos"+ CRLF + ;
                "de Dados, Esto <Amarrados> a Esta Matrcula. Tenha Certeza!!"+ CRLF + ;
                "As Perdas, Podem Ser Irrecuperveis. Tome Cuidado!!!         "+ CRLF + ;
                "Use <Esc> Para Sair, Retorne e Clique No Campo Certo...      "+ CRLF + ;
                "Se Errar, Use Opo <Cancelar> ou <Esc> Para Abortar.    Joo",        ;
                "Por Favor, Pare!!! Erro!! Erro!! Erro!! Erro!! Erro!!" )
   Endif

RETURN lDevuelve

FUNCTION existe_Prod( cCodigo )

   Field Codigo
   Local oDbf
   LOCAL lDevuelve := .T.

   dbSetOrder( 1 )
   dbSeek( cCodigo )

   IF Found()

       SndPlaySound(".\Erro.wav" )

       MsgStop( "Esta Cdigo J  Existe,  No  Insista.  Perigo!!!"+ CRLF + ;
                "Voc S Pode Alterar os Campos Abaixo  da  Matrcula"+ CRLF + ;
                "Use <Esc> Para Sair, Retorne e Clique No Campo Certo"+ CRLF + ;
                "Se Errar, Use Opo <Cancelar> ou <Esc> Para Abortar",        ;
                "Por Favor, Pare!!!" )
       lDevuelve := .F.

   ENDIF

RETURN lDevuelve

// --------------------------------------------------------------------------//

// --------------------------------------------------------------------------//
// Funcao ....: ApagarCli()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Clientes.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// --------------------------------------------------------------------------//
FUNCTION ApagarCli( oDbfClientes )

    FIELD NOME
    FIELD CGC

    LOCAL lApagarCli := .F.
    LOCAL cCodigo    := ""
    LOCAL nRecNo     := (oDbfClientes:cAlias)->( RecNo() )
    LOCAL cNomeCli   := (oDbfClientes:cAlias)->( NOME )

    MEMVAR oNome_Busca
    MEMVAR XNOMEC

    oDbfClientes:GoTo( nRecNo )

    // Busca o CNPJ/CGC do Cliente Para Mostrar...
    IF ValType( oDbfClientes:FieldGet( 9 ) ) = "N"
       cCodigo := AllTrim( Str( oDbfClientes:FieldGet( 9 ) ) )
    ELSEIF ValType( oDbfClientes:FieldGet( 9 ) ) = "D"
       cCodigo := DTOC( oDbfClientes:FieldGet( 9 ) )
    ELSE
       cCodigo := AllTrim( oDbfClientes:FieldGet( 9 ) )
    ENDIF

    IF NetRecLock( oDbfClientes )

         SndPlaySound(".\Erro.wav" )

        IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                     OemToAnsi( "Voc Est Seguro de " + ;
                                "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                     OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                                "Nome: " + cNomeCli ), ;
                                "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
            oDbfClientes:Delete()
            oDbfClientes:UnLock()
        ENDIF

        SndPlaySound(".\Lembrete.wav" )

    ENDIF

    SELECT ( oDbfClientes:cAlias ) // Seleciona o Alias de CLIENTES.Dbf
    GO TOP

    // Volto Para o Get da Busca Incremental e Limpo Tudo.
    // Coloco o GET na Posio 1 Para Nova Busca.
    XNOMEC := SPACE(40)
    xFocus( oNome_Busca )
    oNome_Busca:bGotFocus := { || oNome_Busca:SetPos( 1 ), Nil }

RETURN NIL

// --------------------------------------------------------------------------//
// Funcao ....: ApagarFor()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Clientes.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// --------------------------------------------------------------------------//
FUNCTION ApagarFor( oDbfFornece )

    FIELD NOME
    FIELD CGC

    LOCAL lApagarCli := .F.
    LOCAL cCodigo    := ""
    LOCAL nRecNo     := (oDbfFornece:cAlias)->( RecNo() )
    LOCAL cNomeCli   := (oDbfFornece:cAlias)->( NOME )

    MEMVAR oNome_Busca
    MEMVAR XNOMEC

    oDbfFornece:GoTo( nRecNo )

    // Busca o CNPJ/CGC do Cliente Para Mostrar...
    IF ValType( oDbfFornece:FieldGet( 9 ) ) = "N"
       cCodigo := AllTrim( Str( oDbfFornece:FieldGet( 9 ) ) )
    ELSEIF ValType( oDbfFornece:FieldGet( 9 ) ) = "D"
       cCodigo := DTOC( oDbfFornece:FieldGet( 9 ) )
    ELSE
       cCodigo := AllTrim( oDbfFornece:FieldGet( 9 ) )
    ENDIF

    IF NetRecLock( oDbfFornece )

         SndPlaySound(".\Erro.wav" )

        IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                     OemToAnsi( "Voc Est Seguro de " + ;
                                "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                     OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                                "Nome: " + cNomeCli ), ;
                                "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
            oDbfFornece:Delete()
            oDbfFornece:UnLock()
        ENDIF

        SndPlaySound(".\Lembrete.wav" )

    ENDIF

    SELECT ( oDbfFornece:cAlias ) // Seleciona o Alias de CLIENTES.Dbf
    GO TOP

    // Volto Para o Get da Busca Incremental e Limpo Tudo.
    // Coloco o GET na Posio 1 Para Nova Busca.
    XNOMEC := SPACE(40)
    xFocus( oNome_Busca )
    oNome_Busca:bGotFocus := { || oNome_Busca:SetPos( 1 ), Nil }

RETURN NIL

//---------------------------------------------------------------------------//

// Apagar um Cliente Usando o Alt + Letra, No Pode Ser Igual ao Outro
// Apagar_Cli_Alt_Letra( nKey, nFlags, oDbfClientes, oLbx, oDlg )

FUNCTION  Apagar_Cli_Alt_Letra( nKey, nFlags, oDbfClientes, oLbx, oDlg )

   FIELD NOME
   FIELD CGC

   LOCAL lApagarCli := .F.
   LOCAL cCodigo    := ""
   LOCAL nRecNo     := (oDbfClientes:cAlias)->( RecNo() )
   LOCAL cNomeCli   := (oDbfClientes:cAlias)->( NOME )

   oDbfClientes:GoTo( nRecNo )

   // Busca o CNPJ/CGC do Cliente Para Mostrar...
   IF ValType( oDbfClientes:FieldGet( 9 ) ) = "N"
      cCodigo := AllTrim( Str( oDbfClientes:FieldGet( 9 ) ) )
   ELSEIF ValType( oDbfClientes:FieldGet( 9 ) ) = "D"
      cCodigo := DTOC( oDbfClientes:FieldGet( 9 ) )
   ELSE
      cCodigo := AllTrim( oDbfClientes:FieldGet( 9 ) )
   ENDIF

   IF NetRecLock( oDbfClientes )

       SndPlaySound(".\Erro.wav" )

       IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                    OemToAnsi( "Voc Est Seguro de " + ;
                               "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                    OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                               "Nome: " + cNomeCli ), ;
                               "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
          oDbfClientes:Delete()
          oDbfClientes:UnLock()
      ENDIF

      SndPlaySound(".\Lembrete.wav" )

   ENDIF

RETURN NIL

// ------------------------------------------------------------------------
// Funcao ....: ApagarDev()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Clientes.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// ------------------------------------------------------------------------
FUNCTION ApagarDev( oDbf )

   FIELD RAZMATRIC2
   FIELD DESTNOME2

   LOCAL lApagarCli := .F.
   LOCAL cCodigo    := ""
   LOCAL nRecNo     := (oDbf:cAlias)->( RecNo() )
   LOCAL cNomeCli   := (oDbf:cAlias)->( DESTNOME2 )

   oDbf:GoTo( nRecNo )

   IF ValType( oDbf:FieldGet( 1 ) ) = "N"
      cCodigo := AllTrim( Str( oDbf:FieldGet( 1 ) ) )
   ELSEIF ValType( oDbf:FieldGet( 1 ) ) = "D"
      cCodigo := DTOC( oDbf:FieldGet( 1 ) )
   ELSE
      cCodigo := AllTrim( oDbf:FieldGet( 1 ) )
   ENDIF

   IF NetRecLock( oDbf )

       SndPlaySound(".\Erro.wav" )

       IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                    OemToAnsi( "Voc Est Seguro de " + ;
                               "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                    OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                               "Nome: " + cNomeCli ), ;
                               "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
          oDbf:Delete()
          oDbf:UnLock()
      ENDIF

      SndPlaySound(".\Lembrete.wav" )

   ENDIF

RETURN NIL

// ------------------------------------------------------------------------
// Funcao ....: ApagarPro()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Produtos.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// ------------------------------------------------------------------------
FUNCTION ApagarPro( oDbfEstoque )

    FIELD COD
    FIELD DESC
    FIELD MARCA

    LOCAL lApagarPro := .F.
    LOCAL cCodigo    := " "
    LOCAL nRecNo     := (oDbfEstoque:cAlias)->( RecNo() )
    LOCAL cNomePro   := (oDbfEstoque:cAlias)->( DESC )
    LOCAL cMarcaPro  := (oDbfEstoque:cAlias)->( MARCA )

    MEMVAR XNOMEC
    MEMVAR oNome_Busca

    oDbfEstoque:GoTo( nRecNo )

    IF ValType( oDbfEstoque:FieldGet( 1 ) ) = "N"
       cCodigo := AllTrim( Str( oDbfEstoque:FieldGet( 1 ) ) )
    ELSEIF ValType( oDbfEstoque:FieldGet( 1 ) ) = "D"
       cCodigo := DTOC( oDbfEstoque:FieldGet( 1 ) )
    ELSE
       cCodigo := AllTrim( oDbfEstoque:FieldGet( 2 ) )  // Cnpj
    ENDIF

    IF NetRecLock( oDbfEstoque )

        SndPlaySound(".\Erro.wav" )

        IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                     OemToAnsi( "Voc Est Seguro de " + ;
                                "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                     OemToAnsi( "Cdigo.....:  " + cCodigo  +CRLF+ ;
                                "Descrio:  " + cNomePro +CRLF+ ;
                                "Marca......:  " + cMarcaPro ),    ;
                                "C u i d a d o ! !  P e r d a  I r r e c u p e r  v e l !" ) = .T.
            oDbfEstoque:Delete()
            oDbfEstoque:UnLock()
        ENDIF

        SndPlaySound(".\Lembrete.wav" )

    ENDIF

    SELECT ( oDbfEstoque:cAlias ) // Seleciona o Alias
    GO TOP

    // Volto Para o Get da Busca Incremental e Limpo Tudo.
    // Coloco o GET na Posio 1 Para Nova Busca.
    XNOMEC := SPACE(40)
    xFocus( oNome_Busca )
    oNome_Busca:bGotFocus := { || oNome_Busca:SetPos( 1 ), Nil }

RETURN NIL

// ------------------------------------------------------------------------
// Funcao ....: ApagaProv()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Produtos.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// ------------------------------------------------------------------------
FUNCTION ApagaProv( oDbf )

   FIELD MATRICULA
   FIELD NOME_CLI
   FIELD CODIGO
   FIELD DESCRICAO
   FIELD MARCA

   LOCAL lApagarPro := .F.
   LOCAL cCodigo    := ""
   LOCAL nRecNo     := (oDbf:cAlias)->( RecNo() )
   LOCAL cNomeCli   := (oDbf:cAlias)->( NOME_CLI )
   LOCAL cNomePro   := (oDbf:cAlias)->( DESCRICAO )
   LOCAL cMarcaPro  := (oDbf:cAlias)->( MARCA )

   oDbf:GoTo( nRecNo )

   IF ValType( oDbf:FieldGet( 1 ) ) = "N"
      cCodigo := AllTrim( Str( oDbf:FieldGet( 1 ) ) )
   ELSEIF ValType( oDbf:FieldGet( 1 ) ) = "D"
      cCodigo := DTOC( oDbf:FieldGet( 1 ) )
   ELSE
      cCodigo := AllTrim( oDbf:FieldGet( 1 ) )
   ENDIF

   IF NetRecLock( oDbf )

       SndPlaySound(".\Erro.wav" )

       IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                    OemToAnsi( "Voc Est Seguro de " + ;
                               "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                    OemToAnsi( "Matrcula..:  " + cCodigo      +CRLF+      ;
                               "Nome Cliente: " + cNomeCli     +CRLF+      ;
                               "Descrio:  " + cNomePro       +CRLF+      ;
                               "Marca......:  " + cMarcaPro ),             ;
                               "C u i d a d o ! !  P e r d a  I r r e c u p e r  v e l !" ) = .T.
          oDbf:Delete()
          oDbf:UnLock()
      ENDIF

      SndPlaySound(".\Lembrete.wav" )

   ENDIF

RETURN NIL

// ------------------------------------------------------------------------

// ------------------------------------------------------------------------
// Funcin ...: GetNewAlias
// Descripcin: Asigna un nuevo alias nico, es decir, que no exista.
//              Es imprescindible para trabajo en MDI, al poder abrir
//              la misma ventana varias veces.
// Par metros : cAlias -> Alias asignado previamente.
// Devolve ..: un alias nico.
// Notas .....: Extraida de un ejemplo del uso MDI en Fivewin
//              \SAMPLES\TESTMDI8.PRG
// ------------------------------------------------------------------------
FUNCTION GetNewAlias( cAlias )
   STATIC n := 0
RETURN cAlias + StrZero( ++n, 4 )
// ------------------------------------------------------------------------

// ------------------------------------------------------------------------
// Funcin ...: GetIndices
// Descripcin: Devolve un array con los nombres de los TAGs abiertos.
// Par metros : Ninguno.
// Devolve ..: acIndices -> Array con los nombres.
// Notas .....: De esta forma puede aparecer un nombre inteligible en los
//              browse (combobox al lado botn de Salir).
// ------------------------------------------------------------------------
FUNCTION GetIndices()

   LOCAL i := 0
   LOCAL acIndices := {}

   FOR i := 1 TO 15
       IF !Empty( OrdName( i ) )
          aAdd( acIndices, OrdName( i ) )
       ENDIF
   NEXT

   // Si no hay ningn indice ...
   IF Len( acIndices ) = 0
      aAdd( acIndices, "Nenhum Indice" )
   ENDIF

RETURN acIndices
// ------------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: PictPts
// Descripcin: Cadena Picture para un GET.
// Par metros : Ninguno.
// Devolve ..: Una cadena.
// -----------------------------------------------------------------------
FUNCTION PictPts()
RETURN( "@E 9,999,999,999" )
// -----------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: PictEuros
// Descripcin: Cadena Picture para un GET.
// Par metros : Ninguno.
// Devolve ..: Una cadena.
// -----------------------------------------------------------------------
FUNCTION PictEuros()
RETURN( "@E 9,999,999,999.99" )
// -----------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: Num2StrDec
// Descripcin: Convierte un campo numrico a cadena, para mostrar en un
//              LISTBOX.
// Par metros : nCampo -> Valor Numrico.
// Devolve ..: Cadena formateada.
// -----------------------------------------------------------------------
FUNCTION Num2StrDec( nCampo )
RETURN Transform( nCampo, "@E 999,999,999.99" )
// -----------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: Num2Str
// Descripcin: Convierte un campo numrico a cadena, para mostrarlo en un
//              LISTBOX.
// Par metros : nCampo -> Valor Numrico.
// Devolve ..: Cadena formateada.
// -----------------------------------------------------------------------
FUNCTION Num2Str( nCampo, nSize, nDec )

   LOCAL cPicture := "@E 999,999,999,999"

   DO CASE
      CASE nSize = 12 .AND. nDec = 0
           cPicture := "@E 999,999,999,999"
      CASE nSize = 12 .AND. nDec = 2
           cPicture := "@E 999,999,999.99"
      CASE nSize = 12 .AND. nDec = 3
           cPicture := "@E 99,999,999.999"
      CASE nSize = 08 .AND. nDec = 0
           cPicture := "@E 99,999,999"
      CASE nSize = 08 .AND. nDec = 2
           cPicture := "@E 99,999.99"
      CASE nSize = 08 .AND. nDec = 3
           cPicture := "@E 9,999.999"
      CASE nSize = 07 .AND. nDec = 0
           cPicture := "@E 9,999,999"
      CASE nSize = 07 .AND. nDec = 2
           cPicture := "@E 9,999.99"
      CASE nSize = 07 .AND. nDec = 3
           cPicture := "@E 999.999"
      CASE nSize = 05 .AND. nDec = 0
           cPicture := "@E 99,999"
      CASE nSize = 05 .AND. nDec = 2
           cPicture := "@E 99.99"
      CASE nSize = 05 .AND. nDec = 3
           cPicture := "@E 9.999"
      CASE nSize = 02 .AND. nDec = 0
           cPicture := "99"
   ENDCASE

RETURN Transform( nCampo, cPicture )
// -----------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: Num2Doc
// Descripcin: Convierte un campo numrico a cadena, para mostrarlo en un
//              LISTBOX. Solo para los nmeros de documento.
// Par metros : nCampo -> Valor Numrico.
// Devolve ..: Cadena formateada.
// -----------------------------------------------------------------------
FUNCTION Num2Doc( nCampo )
RETURN Transform( nCampo, "@E 9999999" )
// -----------------------------------------------------------------------

// -----------------------------------------------------------------------
// Funcin ...: IsPar
// Descripcin: Comprueba si un n es par, lo utilizo para cambiar alternar
//              los colores de los browse.
// Par metros : nCampo -> Valor Numrico.
// Devolve ..: .T. o .F.
// -----------------------------------------------------------------------
FUNCTION IsPar( nNumero )

   LOCAL lDevuelve := .F.

   IF ValType( nNumero ) = "N"
      IF nNumero % 2 = 0
         lDevuelve := .T.
      ENDIF
   ENDIF

RETURN lDevuelve

// -----------------------------------------------------------------------

FUNCTION FiltrarM( oDbfClientes )  // Busca Pela Matricula do Cliente

    FIELD NOME
    FIELD CGC

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F2 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    //Set( 9, "ON" )
    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    DbSetOrder( 2 )

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    lAtivo := .T.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=2, "CNPJ/CPF ", "Nome " ) +  ;
                                            " do Cliente",            ;
                              IF( nOrden=1, @nCliente, @cNombre ),    ;
               "Lupa.Bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        LOCATE FOR cNombre $ Nome

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )

            DbSetOrder( 1 )
            Go Top

        ENDIF

    ENDIF

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

    DbSetOrder( 1 )

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FiltrarDevM()  // Busca Pela Matricula do Cliente

    FIELD RAZMATRIC2
    FIELD DESTNOME2

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 1
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F2 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    //Set( 9, "ON" )
    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    DbSetOrder( 1 )

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula ", "Nome " ) + ;
                                           " do Cliente",          ;
                             IF( nOrden=1, @nCliente, @cNombre ),  ;
             "Lupa.Bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        LOCATE FOR cNombre $ DestNome2

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )

            DbSetOrder( 2 )
            DbGoTop()
            //Go Top
            //GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

RETURN NIL

// -----------------------------------------------------------------------

// Busca pelo Nome do Cliente
FUNCTION FiltrarN( cTitle, cText, uVar, cBmpFile, cResName, oDbClientes,      ;
                   oDbfFornece )

    FIELD NOME

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(40)
    LOCAL nRecNo   := RecNo()

    cBmpFile       := "LUPA.BMP"

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    dbSetOrder( 1 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula/Codigo", "Nome" ) +    ;
                                            " do Cliente/Fornecedor",         ;
                              IF( nOrden=1, @nCliente, @cNombre ),            ;
               cBmpFile   )

        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( Nome, 40 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )

            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

    dbSetOrder( 1 )

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FiltrarT( oDbClientes )    // Busca pelo Telefone do Cliente com F4

    FIELD NOME
    FIELD TEL

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F4 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    dbSetOrder( 3 )  // Por Telefone

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .T.  // Aqui F4 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Nome", "Telefone" ) + ;
                                            " do Cliente",          ;
                              IF( nOrden=1, @nCliente, @cNombre ),  ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( Nome, 50 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )

            GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F4 Se Reativa

    dbSetOrder( 1 )

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FiltraDevN()    // Busca pelo Nome do Cliente

    FIELD DESTNOME2

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    dbSetOrder( 2 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", "Nome" ) + ;
                                            " do Cliente",          ;
                             IF( nOrden=1, @nCliente, @cNombre ),   ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( DestNome2, 50 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )

            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FilArtis() // Busca pelo Nome do Cliente Artistico(Apelido)

    FIELD NOME_ARTIS

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F4 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    dbSetOrder( 4 )

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", " Apelido " ) + ;
                                            "do Cliente",                ;
                             IF( nOrden=1, @nCliente, @cNombre ),        ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        __DbLocate( { || PadR( Nome_Artis, 50 ) $ cNombre },,,, .F. )
        //LOCATE FOR PadR( Nome_Artis, 50 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F4 Se Reativa

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FilDArtis() // Busca pelo Nome do Cliente Artistico(Apelido)
                     // Dos Devedores
    FIELD NOMEARTIS

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F4 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    If Eof()
        MsgStop( "Bancos de Dados Bloqueado," + CRLF +;
                 "Acesso Negado!!", "Cuidado!" )
        Return Nil
    Endif

    dbSetOrder( 4 )

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", " Apelido " ) + ;
                                            "do Cliente",                ;
                             IF( nOrden=1, @nCliente, @cNombre ),        ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( NomeArtis, 50 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF

    ENDIF

    // Para Que a Tecla F4 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F4 Se Reativa

RETURN NIL

// -Procurar no Estoque, Pelo Cdigo do Produto---------------------------

FUNCTION FiltraPC()  // Busca Pelo Codigo do Produto

    FIELD COD
    FIELD DESC

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 1
    LOCAL nProduto := SPACE(15) // Cdigo do Produto  Caracter = 15
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    DbSetOrder( 1 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Codigo", "Nome" ) +  ;
                                            " do Produto",        ;
                             IF( nOrden=1, @nProduto, @cNombre ), ;
               "Lupa.bmp" )

        CursorWait()
        cNombre=RTRIM( Upper( cNombre ) )
        LOCATE FOR cNombre $ DESC

        IF !DbSeek( IF( nOrden=1, nProduto, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Produto", OemToAnsi( "Ateno" ) )
            GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

    DbSetOrder( 2 )

RETURN NIL

// -> Pesquisar o Estoque, Pelo Nome do Produto

FUNCTION FiltraPN()    // Busca pelo Nome do Produto

    FIELD DESC

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nProduto := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    DbSetOrder( 2 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Codigo", "Nome" ) +  ;
                                            "do Produto",         ;
                             IF( nOrden=1, @nProduto, @cNombre ), ;
               "Lupa.bmp" )
    
        CursorWait()
        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( DESC, 35 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nProduto, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Produto", OemToAnsi( "Ateno" ) )
            GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

RETURN NIL

//-----------------------------------------------------------------------------

FUNCTION FiltraE()    // Busca pelo Endereo do Cliente

    FIELD END

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 3
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 3 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Codigo", "Nome" ) +  ;
                                            " do Endereo",       ;
                             IF( nOrden=1, @nCliente, @cNombre ), ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        __DbLocate( { || PadR( End, 50 ) $ cNombre },,,, .F. )
        //LOCATE FOR PadR( End, 50 ) $ cNombre

        //PadR( dbFilter(), 60 )

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Endereo", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

RETURN NIL

// -------------------------------------------------------------------------

FUNCTION Del_Comp_M()  // Busca Pela Matricula do Cliente

    FIELD MATRICULA
    FIELD NOME_CLI

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 1
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    SET SOFTSEEK ON

    dbSetOrder( 1 )

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "     Matricula",      ;
                                            "  Nome" ) +           ;
                                            " do Cliente",         ;
                              IF( nOrden=1, @nCliente, @cNombre ), ;
                 "Lupa.bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        __DbLocate( { || cNombre $ Nome_Cli },,,, .F. )
        //LOCATE FOR cNombre $ Nome_Cli

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

RETURN NIL


FUNCTION Del_Comp_N()    // Busca pelo Nome do Cliente

    FIELD NOME_CLI

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 5
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 5 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", "Nome" ) + ;
                                            " do Cliente",          ;
                              IF( nOrden=1, @nCliente, @cNombre ),  ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        __DbLocate( { || PadR( Nome_Cli, 50 ) $ cNombre },,,, .F. )
        //LOCATE FOR PadR( Nome_Cli, 50 ) $ cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

RETURN NIL

//-------------------------------------------------------------------------//

// ------------------------------------------------------------------------
// Funcao ....: ApagaForn()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Clientes.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// ------------------------------------------------------------------------
FUNCTION ApagaForn( oDbf )

   FIELD MATRICULA
   FIELD RAZAO

   LOCAL lApagarCli := .F.
   LOCAL cCodigo    := ""
   LOCAL nRecNo     := (oDbf:cAlias)->( RecNo() )
   LOCAL cNomeForn  := (oDbf:cAlias)->( RAZAO )

   oDbf:GoTo( nRecNo )

   IF ValType( oDbf:FieldGet( 1 ) ) = "N"
      cCodigo := AllTrim( Str( oDbf:FieldGet( 1 ) ) )
   ELSEIF ValType( oDbf:FieldGet( 1 ) ) = "D"
      cCodigo := DTOC( oDbf:FieldGet( 1 ) )
   ELSE
      cCodigo := AllTrim( oDbf:FieldGet( 1 ) )
   ENDIF

   IF NetRecLock( oDbf )

       SndPlaySound(".\Erro.wav" )

       IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                    OemToAnsi( "Voc Est Seguro de " + ;
                               "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                    OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                               "Nome: " + cNomeForn ), ;
                               "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
          oDbf:Delete()
          oDbf:UnLock()
      ENDIF

     SndPlaySound(".\Lembrete.wav" )

   ENDIF

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FiltFornM()  // Busca Pela Fornecedor do Por matricula

    FIELD MATRICULA
    FIELD RAZAO

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 1
    LOCAL nFornece := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 1 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula ", "Nome" ) + ;
                                            " do Fornecedor",        ;
                             IF( nOrden=1, @nFornece, @cNombre ),    ;
               "Lupa.bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        __DbLocate( { || cNombre $ Razao },,,, .F. )
        //LOCATE FOR cNombre $ Razao

        IF !DbSeek( IF( nOrden=1, nFornece, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Fornecedor", ;
            OemToAnsi( "Ateno" ) )

            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

RETURN NIL

FUNCTION FiltFornN()    // Busca pelo Nome do Fornecedor

    FIELD RAZAO

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nFornece := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 2 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula ", "Nome" ) + ;
                                           " do Fornecedor",        ;
                             IF( nOrden=1, @nFornece, @cNombre ),   ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        __DbLocate( { || PadR( Razao, 50 ) $ cNombre },,,, .F. )
        //LOCATE FOR PadR( Razao, 50 ) $cNombre

        IF !DbSeek( IF( nOrden=1, nFornece, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Fornecedor", ;
            OemToAnsi( "Ateno" ) )

            DbGoTo(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

RETURN NIL

//-> Busca/Procura o Operador, Pelo Cdigo, Controle dos Acessos.

FUNCTION Busca_Opera_Codigo( oDbfVendedor )

    FIELD COD
    FIELD NOME

    LOCAL oLbx
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden    := 1
    LOCAL nVendedor := SPACE(07) // 0 -> Cdigo  Alfa. No Numrico
    LOCAL cNombre   := SPACE(30)
    LOCAL nRecNo    := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    DbSetOrder( 1 ) //-> Busca Por Cdigo do Vendedor.

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .T.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Codigo ", "Nome " )  +           ;
                                            "do Vendedor",                    ;
                              IF( nOrden=1, @nVendedor, @cNombre ),           ;
               "Lupa.bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        LOCATE FOR cNombre $ Nome

        IF !DbSeek( IF( nOrden=1, nVendedor, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Fornecedor", ;
            OemToAnsi( "Ateno" ) )

            GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa

RETURN NIL

//-> Busca/Procura o Operador, Pelo Nome, Controle dos Acessos.

FUNCTION Busca_Nome_Operador( oDbfVendedor )

    FIELD NOME

    LOCAL oLbx
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden    := 2
    LOCAL nVendedor := SPACE(07)
    LOCAL cNombre   := SPACE(40)
    LOCAL nRecNo    := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    DbSetOrder( 2 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .T.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Codigo", "Nome" )      + ;
                                            " do Vendedor",           ;
                              IF( nOrden=1, @nVendedor, @cNombre ),   ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        LOCATE FOR PadR( Nome, 40 ) $cNombre

        IF !DbSeek( IF( nOrden=1, nVendedor, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Fornecedor", ;
            OemToAnsi( "Ateno" ) )

            GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Reativa
    DbSetOrder( 1 )

RETURN NIL

// -----------------------------------------------------------------------

// ------------------------------------------------------------------------
// Funcao ....: ApagaPorta()
// Descricao..: Apagar o registro selecionado no LISTBOX dos Clientes.
// Parametros : oDbf -> Objeto DATABASE com os campos do Arquivo.
// Devolve ...: Nada.  nothing
// ------------------------------------------------------------------------
FUNCTION ApagaPorta( oDbf )

   FIELD MATRICULA
   FIELD EMPRESA

   LOCAL lApagarCli := .F.
   LOCAL cCodigo    := ""
   LOCAL nRecNo     := (oDbf:cAlias)->( RecNo() )
   LOCAL cNomeEmp   := (oDbf:cAlias)->( EMPRESA )

   oDbf:GoTo( nRecNo )

   IF ValType( oDbf:FieldGet( 1 ) ) = "N"
      cCodigo := AllTrim( Str( oDbf:FieldGet( 1 ) ) )
   ELSEIF ValType( oDbf:FieldGet( 1 ) ) = "D"
      cCodigo := DTOC( oDbf:FieldGet( 1 ) )
   ELSE
      cCodigo := AllTrim( oDbf:FieldGet( 1 ) )
   ENDIF

   IF NetRecLock( oDbf )

       SndPlaySound(".\Erro.wav" )

       IF MsgYesNo( OemToAnsi( "Ateno:" ) + CRLF + ;
                    OemToAnsi( "Voc Est Seguro de " + ;
                               "Querer Apagar Este Registro?" )+CRLF+CRLF+ ;
                    OemToAnsi( "Matrcula: " + cCodigo +CRLF+ ;
                               "Nome: " + cNomeEmp ), ;
                               "C u i d a d o ! !  Perda Irrecupervel!" ) = .T.
          oDbf:Delete()
          oDbf:UnLock()
      ENDIF

      SndPlaySound(".\Lembrete.wav" )

   ENDIF

RETURN NIL

// -----------------------------------------------------------------------

FUNCTION FiltraPortaM()  // Busca Pela Matricula do Cliente

    FIELD MATRICULA
    FIELD EMPRESA

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 1
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 1 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", "Nome" ) + ;
                                            " do Cliente",          ;
                             IF( nOrden=1, @nCliente, @cNombre ),   ;
               "Lupa.bmp" )

        cNombre=RTRIM( Upper( cNombre ) )
        __DbLocate( { || cNombre $ Empresa },,,, .F. )
        //LOCATE FOR cNombre $ Empresa

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", OemToAnsi( "Ateno" ) )
            DbGoto(nRecNo)
            GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

RETURN NIL

FUNCTION FiltrarPPN()    // Busca pelo Nome do Cliente

    FIELD EMPRESA

    LOCAL oLbx
    LOCAL oDbf
    LOCAL cCodigo
    LOCAL oDlg
    LOCAL oFont
    LOCAL nOrden   := 2
    LOCAL nCliente := 0
    LOCAL cNombre  := SPACE(30)
    LOCAL nRecNo   := RecNo()

    // Para Que a Tecla F2 No Se Acione + de 1 vez
    If lAtivo // Se F3 J  estiver Acionado, Retornar Nulo.
        Return Nil  // Desativada Tecla de Funo...
    Endif

    SET SOFTSEEK ON

    dbSetOrder( 2 )

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .t.  // Aqui F2 Se Desativa

    IF MsgGet( "Buscar Por:", IF( nOrden=1, "Matricula", "Nome" ) + ;
                                            " do Cliente",          ;
                             IF( nOrden=1, @nCliente, @cNombre ),   ;
               "Lupa.bmp" )

        cNombre := ALLTRIM( Upper( cNombre ) )
        __DbLocate( {|| PadR( Empresa, 50 ) $ cNombre },,,, .F. )
        //LOCATE FOR PadR( Empresa, 50 ) $cNombre

        IF !DbSeek( IF( nOrden=1, nCliente, cNombre ) )

            SndPlaySound(".\Erro.wav" )
            nMsgBox( "No Encontrei Este Cliente", ;
            OemToAnsi( "Ateno" ) )

            DbGoto(nRecNo)
            //GO nRecNo

        ENDIF
    ENDIF

    // Para Que a Tecla F3 No Se Acione + de 1 vez
    lAtivo := .F.  // Aqui F2 Se Desativa

RETURN NIL

// ----------------------------------------------------------------------------

// Maravilhoso Ednaldo Cabra Bom!!!
//----------------------------------------------------------------------------//
// Funcao    : ImpSpool( cFileTxt, cPorta, lErase )
// Autor     : Ednaldo Rolim (edrol@pop.com.br)
// Descricao : Envia um arquivo TXT criado pela TDosPrn para uma 
//             porta de Impressora.
//----------------------------------------------------------------------------//
Function ImpSpool( cFileTxt, cPorta, lErase )

    //para capturar antes da impresso

    //cPorta := PrnGetPorta()

    //WinExec( cPorta )

    //depois da impresso

    //WinExex( "Net Use Lpt1: \Delete" )

    //Ficou mais facil e simples do que criar as portas na Classe TDosPrn

    //cPorta := If( cPorta == nil, Alltrim( PrnGetPort() ), cPorta ) ; lErase := If( lErase == nil, .T., lErase );

    Default cPorta:= Alltrim( PrnGetPort() ), lErase:= .t.
    
    If !File( cFileTxt )
        return .F.
    Endif
 
    If Len( cPorta ) <= 5 .and. Left( Upper(cPorta), 4) = "LPT1"
        //--- Spool Local
        cPorta:= "PRN"
        WAITRUN("COMMAND.COM /C COPY /B " + cFileTxt + " " + cPorta, 0 )
     Else
        //--- Spool Remoto
        WAITRUN("COMMAND.COM /C COPY /B " + cFileTxt + " " + cPorta, 0 )
    Endif

    If lErase
        FErase( cFileTxt )
    Endif

Return .T.

//-Chamar a Calculadora do Windows--------------------------------------------//

/*
FUNCTION Set_Calc() // Para que ela se abra somente uma vez
                    // Usa-se TWCapture.prg www.dbwide.com.ar
                    // ca-windows.prg baixei pela Internet.

    LOCAL oWCalc:=TWCapture():New("Calculadora")

    IF oWCalc:lCaptured
       oWCalc:Restore()
       oWCalc:GoTop()
       SendMessage( FindWindow( 0, "Calculadora" ), WM_CLOSE )
    ELSE
       WinExec( "Calc.Exe", SW_NORMAL )
    ENDIF

RETURN (NIL)
*/

// --------------------------------------------------------------------- //

Function Set_Calc()   //Calculadora() // Outra Opo = Melhor.

    LOCAL hWnd

    If ( hWnd := SeekCalculadora() ) == 0
        WinExec( 'Calc.Exe', SW_NORMAL )
     Else
        BringWindowToTop( hWnd )
        ShowWindow( hWnd, SW_RESTORE )
   Endif

Return Nil

 // ------------------------------------------------------------------ //

STATIC Function SeekCalculadora()

    LOCAL aCaptions := { 'Calc', 'Calculator', 'Calculadora' }
    LOCAL nPos, hWnd

    For nPos = 1 to Len(aCaptions)
        If ( hWnd := FindWindow( 0, aCaptions[nPos] ) ) > 0
            Return hWnd
        EndIf
    Next

Return hWnd

//----------------------------------------------------------------------------//

Function CheckCGC(cCGC)

    LOCAL nDigito4

    LOCAL nDigito1 := nDigito4 := 0, nVez := 1, nConta, nResto, nDigito

    FOR nConta := 1 TO LEN( cCGC ) - 2

        IF AT( SUBS( cCGC, nConta,1 ), "/-." ) == 0
            nDigito1 := nDigito1 + VAL( SUBS( cCGC, nConta,1 ) ) * ;
                                      ( IF( nVez < 5,6,14 ) - nVez )

            nDigito4 := nDigito4 + VAL( SUBS( cCGC, nConta,1 ) ) * ;
                                      ( IF( nVez < 6,7,15 ) - nVez )
            nVez ++
        ENDIF

    NEXT

    nResto   := nDigito1 - ( INT( nDigito1 / 11 ) * 11 )
    nDigito  := IF( nResto < 2,0,11 - nResto )
    nDigito4 := nDigito4 + 2 * nDigito
    nResto   := nDigito4 - ( INT( nDigito4 / 11 ) * 11 )
    nDigito  := VAL( STR( nDigito,1 ) + STR( IF( nResto < 2,0,11 - nResto),1 ) )

    IF nDigito <> VAL( SUBS( cCGC, LEN( cCGC ) - 1,2 ) )

        SndPlaySound(".\Erro.wav" )

        MsgAlert( "Ateno: Este Nmero de C.N.P.J." +CRLF+ ;
                  "No  Vlido No Brasil...       " +CRLF+ ;
                  "Confira o Nmero Com Cuidado!   ",       ;
                  "Ateno: Verifique!" )
        RETURN .F.
     ELSE
        RETURN .T.
    ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

Function CheckCPF(cCIC)

    LOCAL nDigito2
    LOCAL nDigito1 := nDigito2 := 0
    LOCAL nVez     := 1, nConta, nResto, nDigito

    FOR nConta := 1 TO LEN(cCIC)-2
        IF AT(SUBS(cCIC,nConta,1),"/-.") == 0
            nDigito1 := nDigito1+(11-nVez)*VAL(SUBS(cCIC,nConta,1))
            nDigito2 := nDigito2+(12-nVez)*VAL(SUBS(cCIC,nConta,1))
            nVez ++
        ENDIF
    NEXT

    nResto   := nDigito1-(INT(nDigito1/11)*11)
    nDigito  := IF(nResto < 2,0,11-nResto)
    nDigito2 := nDigito2 + 2 * nDigito
    nResto   := nDigito2 - (INT(nDigito2/11)*11)
    nDigito  := VAL(STR(nDigito,1)+STR(IF(nResto<2,0,11-nResto),1))

    IF nDigito <> VAL(SUBS(cCIC,LEN(cCIC)-1,2))

        SndPlaySound(".\Erro.wav" )

        MsgAlert( "Ateno: Este Nmero de CIC/CPF" +CRLF+ ;
                  "No  Vlido No Brasil...      " +CRLF+ ;
                  "Confira o Nmero Com Cuidado!  ",       ;
                  "Ateno: Verifique!" )
        RETURN .F.
     ELSE
        RETURN .T.
    ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

//FUNCTION HELPINDEX()
//
//RETURN NIL

//----------------------------------------------------------------------------

/*
PROCEDURE ERRORSYS()

    // Para, Caso Alguem Tente Descompilar Meu Programa Com Algum
    // descompilador Novo, Vai Quebrar a Cara. Joo. 11/01/2003
    MEMVAR  ERRORSYS
    PRIVATE ERRORSYS

    ERRORSYS := 9876543210

RETURN NIL
*/

//-----------------------------------------------------------------------------

FUNCTION MEUBRUSH( oDlg, oBmp )  // Coloca Uma BMP Nas Minhas Dialogs.

    LOCAL mhDC := oDlg:hDC, mHBMP := oBmp:hBitmap

    LOCAL vLin:=0, vCol:=0, hLin:=0, hCol:=0

    LOCAL aHV_Bmp := { oBmp:nHeight(), oBmp:nWidth() } ,;
          aHV_Dlg := { oDlg:nHeight(), oDlg:nWidth() }

    LOCAL lLin := .F.,  lCol := .F.

    if aHV_Bmp[1] > aHV_Dlg[1]
        lLin:=.t.
    Endif

    if aHV_Bmp[2] > aHV_Dlg[2]
        lCol:=.t.
    Endif

    IF lLin .and. lCol
        DrawBitmap( mhDC, mHBMP, vLin, vCol, Nil, Nil, Nil)
        RETURN NIL
    ENDIF

    WHILE .T.

        DrawBitmap( mhDC, mHBMP, IF( lLin, 0, vLin ), ;
            IF( lCol, 0, vCol ), Nil, Nil, Nil )

        IF vLin > aHV_Dlg[1] .AND. vCol > aHV_Dlg[2]
            EXIT
         ELSE
            if vLin > aHV_Dlg[1]
                vLin := 0
             ELSE
                vLin+=aHV_Bmp[1]
            ENDIF

            IF vCol > aHV_Dlg[2]
                 vCol := 0
              ELSE
                vCol+=aHV_Bmp[2]
            ENDIF
        ENDIF

    ENDDO

RETURN NIL

//---------------------------------------------------------------------------//

/*
Function DrawWindow(oWnd,oBmp,lTiled)

    Local x, y
    Local nRow:=0, nCol:=0, nWidth:=oWnd:nWidth, nHeight:=oWnd:nHeight

    Static cBmpData
    DEFAULT cBmpData:=IF(aScan(aoData(oBmp),{|u| u=="HBITMAP"})>0,"hBitmap",;
                          "hBmpPal")
    DEFAULT lTiled:=.F.

    IF !lTiled
        DrawBitmap( oWnd:hDC, oSend(oBmp,cBmpData),nRow, nCol, nWidth, nHeight )
     ELSE
        for y:=0 to oWnd:nHeight STEP oBmp:nHeight
            for x:=0 to oWnd:nWidth STEP oBmp:nWidth
               DrawBitmap( oWnd:hDC, oSend(oBmp,cBmpData), y, x, oBmp:nWidth, ;
                           oBmp:nHeight )
            next
        next
    ENDIF

Return Nil
*/

//----------------------------------------------------------------------------//

// Click nos Actions e Botes.
FUNCTION Click()

    SndPlaySound( "Click.Wav" )

RETURN Nil

//----------------------------------------------------------------------------//

// Fechar a Calculadora do Windows
FUNCTION FechaAPPEx( oWndMain )

    SendMessage( FindWindow( 0, "Calculadora" ), WM_CLOSE )

Return Nil

//----------------------------------------------------------------------------//

// Arquivo.prg
FUNCTION SistemaOK()

    LOCAL lArquivo := .T.
    LOCAL lReport  := .T.
    LOCAL lOk, nHandLes

    IF !File( "\Windows\System\Video.dll" )

        MsgInfo( OemToAnsi( "Imposivel Encontrar o Seguinte Arquivo:"     ;
                                                          + CRLF + CRLF + ;
                            "\Windows\System\<VIDEO.DLL>"                 ;
                                                          + CRLF + CRLF + ;
                            "Sem Este Arquivo o Programa "              + ;
                            "No Pode Executar-se Corretamente"           ;
                                                          + CRLF + CRLF + ;
                            "Acheo-o e Copie Para: C:\Windows\System\" ), ;
                 OemToAnsi( "Informao: karinhannah@ubbi.com.br (11)3106-2832" ) )

        lArquivo := .F.
        __QUIT()
    ENDIF

    IF !File( "\Windows\System\Ctl3D.dll" )

        MsgInfo( OemToAnsi( "Imposivel Encontrar o Seguinte Arquivo:"     ;
                                                          + CRLF + CRLF + ;
                            "\Windows\System\<CTL3D.DLL>"                 ;
                                                          + CRLF + CRLF + ;
                            "Sem Este Arquivo o Programa "              + ;
                            "No Pode Executar-se Corretamente"           ;
                                                          + CRLF + CRLF + ;
                            "Acheo-o e Copie Para: C:\Windows\System\" ), ;
                 OemToAnsi( "Informao: karinhannah@ubbi.com.br (11)3106-2832" ) )

        lArquivo := .F.
        __QUIT()
    ENDIF

    IF !File( "\Windows\System\Bwcc.dll" )

        MsgInfo( OemToAnsi( "Imposivel Encontrar o Seguinte Arquivo:"     ;
                                                          + CRLF + CRLF + ;
                            "\Windows\System\<BWCC.DLL>"                  ;
                                                          + CRLF + CRLF + ;
                            "Sem Este Arquivo o Programa "              + ;
                            "No Pode Executar-se Corretamente"           ;
                                                          + CRLF + CRLF + ;
                            "Acheo-o e Copie Para: C:\Windows\System\" ), ;
                 OemToAnsi( "Informao: karinhannah@ubbi.com.br (11)3106-2832" ) )

        lArquivo := .F.
        __QUIT()
    ENDIF

    IF !File( "\Windows\System\Preview.dll" )

        MsgInfo( OemToAnsi( "Imposivel Encontrar o Seguinte Arquivo:"     ;
                                                          + CRLF + CRLF + ;
                            "\Windows\System\<PREVIEW.DLL>"               ;
                                                          + CRLF + CRLF + ;
                            "Sem Este Arquivo o Programa "              + ;
                            "No Pode Executar-se Corretamente"           ;
                                                          + CRLF + CRLF + ;
                            "Acheo-o e Copie Para: C:\Windows\System\" ), ;
                 OemToAnsi( "Informao: karinhannah@ubbi.com.br (11)3106-2832" ) )

        lReport := .F.
        __QUIT()
    ENDIF

    IF lArquivo .OR. lReport == .F.
        RETURN .F.
    ENDIF

    If nHandLes < 70
        MsgStop( "Este Programa Necessita de Mais Recursos" + CRLF + ;
                 "Para Funcionar Melhor, Feche Alguns Apli" + CRLF + ;
                 "Cativos(Programas)                      " + CRLF + ;
                 "E Volte a Tentar de Novo!", "Aviso!" )
        Quit
    Endif

RETURN lOk

//----------------------------------------------------------------------------//

/*
 *	FlashWndTimer()
 *	Flash Windows from API
 *
 *	Andrade A. Daniel - 2001
 *      Rosario, Argentina  -  www.dbwide.com.br
 */

# include "FiveWin.ch"

/*
 *	FlashWndTimer( <ohWnd>, [<nDelay>], [<bWhen>] )
 *
 *	ohWnd	- Objeto Window/Dialog o Puntero del Objeto
 *	nDelay	- n Milisegundos del Timer
 *	bWhen	- Condicin para ejecutar el Flashing
 *
 */
FUNCTION FlashWndTimer( ohWnd, nDelay, bWhen, oWndMain )

    Local oTmr

    //Em Ingles/FiveWin
    DEFAULT nDelay  := 500
    DEFAULT bWhen   := { || .T. }

    DEFINE TIMER oTmr INTERVAL nDelay ACTION Flashing( ohWnd, bWhen )
    ACTIVATE TIMER oTmr

RETURN oTmr

/*
 *      Flashing()
 */
STATIC FUNCTION Flashing( ohWnd, bWhen )

    Static nStatus := 0
    Local  hWnd

    hWnd := IIF( ValType(ohWnd) != "O", ohWnd, ohWnd:hWnd )

    If Eval( bWhen, hWnd )
        FlashWnd( hWnd, ( nStatus := IIF( nStatus == 1, 0, 1 ) ) )
    Endif

RETURN .T.

DLL32 STATIC FUNCTION FlashWnd( hWnd AS LONG, nInvert AS LONG ) ;
      AS LONG PASCAL FROM "FlashWindow" LIB "User32.dll"

// Declare Function FlashWindow Lib "user32" Alias "FlashWindow"
// (ByVal hwnd As Long, ByVal bInvert As Long) As Long

// [AD-2001] - Daniel Andrade, www.dbwide.com.ar - 2001

//----------------------------------------------------------------------------//

/*
// Esta em Picture.Prg

//   Local oDlg, oGet, oBtn
//   Local lTest := .t.
//   Local cTipo := "J", oTEST1,oTest2
//   Local cCGCCPF := Space(14)

// @ 10, 2 GET oTEST1 VAR cTipo pixel OF oDlg PICTURE "!";
//         valid VerificaAltera(cTipo,oTest2,@cCgcCpf)

Function VerificaAltera(cTipo,oGet,cCgc)

    If !cTipo$"F/J"
        MsgStop("Deve ser digitado (F)isicio (J)uridico","Teste")
        Return(.F.)
    Endif

    /*
    If cTipo="J".and.oGet:cPicture!="@R 99.999.999/9999-99"
        cCgc:=Space(14)
        oGet:cPicture:="@R 99.999.999/9999-99"
        oGet:oGet:Picture:="@R 99.999.999/9999-99"
        oGet:Refresh()
     ElseIf cTipo="F".and.oGet:cPicture!="@R 999.999.999-99"
        cCgc:=Space(11)
        oGet:cPicture:="@R 999.999.999-99"
        oGet:oGet:Picture:="@R 999.999.999-99"
        oGet:Refresh()
    Endif
    */

Return(.t.)
*/

//----------------------------------------------------------------------------//
//*       FUNCIONES DE INTERNET         *
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//

// Para Executar o OutLook Express Direto no Windows 2000 e XP e Demais Verses
/*
// IsWin2000()
// IsWinXP()
// IsNTPreWin2K()
// IsNTWorkstation()
// IsNTServer()
// IsWin2000Prof()
// IsWin2000Server()
*/
FUNCTION MeuWinExec( cParametro )

    //LOCAL cExec := GetPvProfString("Editor","Pgm","notepad", cIniFile )
    LOCAL cExecute := GetPvProfString( "" )

    // NT, 2000 e XP
    IF  IsWinNT() .OR. IsWin2000()
        cExecute := GetEnv( "COMSPEC" ) + " /C "
    ENDIF

RETURN WinExec( cExecute + cParametro, 0 )

//----------------------------------------------------------------------------//

// Archiva.prg  // Funcionou - Outro Exemplo
FUNCTION Internet( cUrl )

    Local cVersion

    cUrl := IF( "@" $ cUrl, "mailto:" + cUrl, cUrl )

    IF Empty( cUrl )
        MsgInfo( "Introduza Algum Valor No Campo", cVersion )
     ELSE
        IF IsWinNT() .OR. isWin2000() // XP/2000/NT
            WinExec( "rundll32.exe url.dll, FileProtocolHandler " + cUrl, 0 )
         ELSE
            WinExec( "Start " + cUrl, 0 )
        ENDIF
    ENDIF

RETURN Nil

//---------------------------------------------------------------------------//

Function SayRotated( oWnd, Y, X, cPrompt, oFont, nClrText, nClrPane, l3D )

  Local hDC := oWnd:hDC

  DEFAULT nClrText := CLR_HRED, l3D := .T.
  
  IF l3D
    DrawRotated( hdc, cPrompt, Y + 1, X + 1, CLR_BLACK, nClrPane, oFont )
    DrawRotated( hdc, cPrompt, Y - 1, X - 1, nClrText, nClrPane, oFont )
  ENDIF

  DrawRotated( hdc, cPrompt, Y , X , nClrText, nClrPane, oFont )

Return Nil

//----------------------------------------------------------------------------

Static Function DrawRotated( hDC, cPrompt, Y, X, nClrText, nClrPane, oFont )

  Local hOldFont, nOldMode, nOldClrText, nOldClrPane, nOldBkMode

  nOldClrText := SetTextColor( hDC, nClrText )

  if nClrPane <> Nil
    nOldClrPane := SetBkColor( hDC, nClrPane )
  else
    nOldBkMode := SetBkMode( hDC,1 )
  Endif

  hOldFont := SelectObject( hDC, oFont:hFont )

  TextOut( hDC, Y, X, cPrompt, Len( cPrompt ) )

  SelectObject( hDC, hOldFont )

  if nClrPane<>nil
    SetBkColor( hDC, nOldClrPane )
  else
    SetBkMode( hDC, nOldBkMode )
  Endif

  SetTextColor( hDC, nOldClrText )

Return Nil

//----------------------------------------------------------------------------

Function Logo()

    //SndPlaySound(".\Carro.Wav" )

    SndPlaySound(".\Init.Wav" )

    MsgLogo( "LOGO.BMP", 3 )

Return(.T.)

//---------------------------------------------------------------------------//

// Use this function to Register your EXEs before distributing them
// Use Esta Function Para Registrar Seus Execut veis Para Ento Distribui-los.

// Just for copy protected versions of FiveWin - de Userid.prg

//----------------------------------------------------------------------------//

Function Registro() //Main()

   //RegisterExe()

Return Nil

//---------------------------------------------------------------------------//

// BMPXP.PRG - By Daniel Andrade... 19/08/2003.
//
// Para Usar Uma BitMap em: W98, 2K, XP
/*
// Problema con un BMP usado como Brush...

// Buenas...
// Tengo el siguiente problema...
// Estoy usando un .bmp como brush de fondo de una
// ventana...
// En mi mquina funciona correctamente tengo Windows 98...

// Lo paso a otra mquina con windows 2000 o 95 y slo
// muestra el color del fondo del .bmp
// El archivo est correcto...en el directorio especificado...
// La configuracin de la pantalla en pixeles y colores es
// la misma en ambas mquinas...
                         
// Desde ya...muchas gracias...

// Re: Problema con un BMP usado como Brush... By Daniel Andrade
*/

//  DEFINE BITMAP oFill RESOURCE "FONDO"
                         
//  DEFINE WINDOW oWnd FROM 0, 0 ;
//         TO MaxRow(), MaxCol()  ;
//         TITLE cName      ;
//         MENU BuildMenu() ;
//         MDI
//
//  oWnd:bPainted := {|hDC| BmpTiled( hDC, oWndMain, oFill ) }
//
//  ACTIVATE WINDOW oPublic:oWndMain MAXIMIZED
//
//  oFill:End(); oFill := NIL

STATIC FUNCTION BmpTiled( hDC, oWndMain, oBmp )
                         
    Local nWidth    := oWndMain:nWidth(), nHeight := oWndMain:nHeight()
    Local nRow      := 0, nCol := 0, n
    Local nBmpWidth := oBmp:nWidth(), nBmpHeight := oBmp:nHeight()
                         
    While nRow < nHeight

        nCol = 0

        While nCol < nWidth
            PalBmpDraw( hDC, nRow, nCol, oBmp:hBitmap )
            nCol += nBmpWidth
        EndDo

        nRow += nBmpHeight

    EndDo
                         
RETURN NIL

//Function Minimize( oWndMain )

// Para minimizar uma janela, veja TestCapt.Prg
//   oDlg:Minimize()
// oDlg:Normal()
   //oWndMain:Capture()

//Return Nil
                         
// Funciona en W98, 2K, XP

//---------------------------------------------------------------------------//
/*
// Inverter Boto do Mouse
// Fao a Chamada de Meu Menu Principal
//Function Main()

    //Invert botes
    //SwapMouseButton( 1 ) // Boto Direito

    // Volta ao Normal
    //SwapMouseButton( 0 ) // Boto Esquerdo

//Return Nil
*/

//-----------------------------------------------------------------------------

Function Desliga_Rato()

   ShowCursor( 0 ) // Desliga Mouse Move
   SysRefresh()
   
Return Nil

//-----------------------------------------------------------------------------

Function Religa_Rato()

   ShowCursor( 1 ) // Re-Liga Mouse Move //2

   // Outra Opo
   //SetCursorPos( ( 1 ), ( 2 ) ) // Re-Liga Mouse Move
   SysRefresh()

Return Nil

//-----------------------------------------------------------------------------

Function Canhotos()

   // Inverte botao do Ratinho
   SwapMouseButton( 1 )  // Para Canhotos

Return Nil

//-----------------------------------------------------------------------------

Function Destros()

   // Volta ao Normal
   SwapMouseButton( 0 ) // Para Destros

Return Nil

// Obrigatrio Incluir Esta Chamada a "C:\Windows\System\USER32.DLL"
//DLL32 FUNCTION SwapMouseButton(swap AS 7) AS 7 PASCAL LIB "USER32.DLL"

DLL32 FUNCTION SwapMouseButton(swap AS 7) AS 7 PASCAL LIB "C:\Windows\System32\USER32.DLL"

//-----------------------------------------------------------------------------

/*
// Antonio Carlos Pantaglione
// Toninho@fwi.com.br
// Ago/2001

#include "fivewin.ch"

procedure main()

  CtrlAltDel( .f. )

  MsgAlert( "CTRL-ALT-DEL DESLIGADO" + CRLF + "Please, press CTRL + ALT + DEL", "Desligado" )

  CtrlAltDel( .t. )

  MsgAlert( "CTRL-ALT-DEL LIGADO" + CRLF + "Please, press CTRL + ALT + DEL", "Ligado" )

return

*/

// Antonio Carlos Pantaglione
// Toninho@fwi.com.br
// Ago/2001

/*
#include "fivewin.ch"
#include "dll.ch"

//----------------------------------------------------------------------------//

Procedure CtrlAltDel( lState )

   if !lState
      SysParInfo( 97, 1, 0, 0 )
   else
      SysParInfo( 97, 0, 0, 0 )
   endif

return

//----------------------------------------------------------------------------//

dll32 static function SysParInfo( uAction AS LONG, uParam AS LONG, vParam AS LONG, uWinIni AS LONG ) ;
      AS LONG PASCAL  FROM "SystemParametersInfoA" LIB "User32.dll"

//----------------------------------------------------------------------------//
*/

// SIMULAR KEYBOARD (1)

FUNCTION FwKeyboard( oWnd, nKey )

    oWnd:SetFocus()
    oWnd:PostMsg( WM_KEYDOWN, nKey, 0 ) //0

RETURN NIL

//Exemplo:  oGet:bGotFocus := { || FwKeyboard( oGet, 36 ) }

//-----------------------------------------------------------------------------

FUNCTION CHECA_ANO()

    MEMVAR CHEK_ANO               // VARIAVEL GLOBAL PARA O ANO CORRENTE

    CHEK_ANO := ( DATE() )        // ANO DE TRABALHO ATUAL

    IF CHEK_ANO <= CTOD('31/12/2003')

        SysWait( 1.5 )

        SndPlaySound(".\Erro.wav" )

        MsgStop ( "Ateno:  Prezado  Usurio  Sistema   Est" + CRLF + ;
                  "Vencido, Portanto No  Possvel Continuar" + CRLF + ;
                  "Por  Favor  Entre  Em  Contato  Com  o Seu" + CRLF + ;
                  "Programador, e Pea a Nova Verso!          " + CRLF + ;
                  "E_mail: karinhannah@ubbi.com.br           " + CRLF + ;
                  "Fone: (11) 3106-2832 / 222-1567 / 223-2001" + CRLF + ;
                  "Falar Com Joo ou Rodrigo Ribas, Obrigado!",         ;
                  "Ateno, Expirou Prazo!" )

        //ABOUT()

        __QUIT()

        RETURN NIL

     ELSEIF CHEK_ANO >=  CTOD('31/12/2005')

        SysWait( 1.5 )

        SndPlaySound(".\Erro.wav" )

        MsgStop ( "Ateno:  Prezado  Usurio  Sistema   Est" + CRLF + ;
                  "Vencido, Portanto No  Possvel Continuar" + CRLF + ;
                  "Por  Favor  Entre  Em  Contato  Com  o Seu" + CRLF + ;
                  "Programador, e Pea a Nova Verso!          " + CRLF + ;
                  "E_mail: karinhannah@ubbi.com.br           " + CRLF + ;
                  "Fone: (11) 3106-2832 / 222-1567 / 223-2001" + CRLF + ;
                  "Falar Com Joo ou Rodrigo Ribas, Obrigado!",         ;
                  "Ateno, Expirou Prazo!" )

        //ABOUT()

        __QUIT()

        RETURN NIL

    ENDIF

RETURN NIL

//-----------------------------------------------------------------------------

FUNCTION CHECA_IMP()

    MsgStop( "Ateno:                            " + CRLF + ;
             "Sua Impressora No Esta Ligada!!!   " + CRLF + ;
             "Favor Verificar Para Poder Imprimir." + CRLF + ;
             "Se Errar, Tente Novamente...        ",         ;
             "Por Favor, Pare!!!" )

RETURN NIL

//-------------------------------------------------------------------------//
// As vezes simples SetFocus( oObj ) nao faz um objeto ganhar foco
// neste caso pode apelar para estas duas funcoes a seguir
// Forar foco para um objeto especifico - Ednaldo Rolim...
//-------------------------------------------------------------------------//
FUNCTION xSetFocus( oObj )

    LOCAL _oWnd := oObj:oWnd, _oTempo := ""

    DEFINE Timer _oTempo Interval 10 of _oWnd ;
           Action ( oObj:SetFocus(), _oTempo:End() )
    ACTIVATE Timer _oTempo

RETURN .T.

//-------------------------------------------------------------------------//
FUNCTION xFocus( oObj )

    xSetFocus( oObj )
    xSetFocus( oObj )

RETURN .T.

//--------------Para Colocar Cor No cabealho do Folder----------------------//
//--------------Est Em \FIVEWIN\Exemplos.Zip O Original---------------------//

Function FoldResize( oWnd, oFld ) // Quando alterei, isto no foi necessarios

   Local oRect := oWnd:GetCliRect()

   oFld:Move( 0, 0, oRect:nRight - oRect:nLeft, ;
   oRect:nBottom - oRect:nTop , .T. )

Return Nil

Function FillWnd( oWnd, nColor, oBmp, nSaltos )

    Local hWnd    := oWnd:hWnd
    Local aRect   := GetClientRect( hWnd )
    Local oBrush, n
    Local nTop    := aRect[ 1 ]
    Local nBottom := aRect[ 3 ]
    Local nSteps
    Local nBlue, nRed, nGreen
    Local lPuro   := .F. // LoadIniPure() // Si es puro no hay degradado

    // Color de degradado
    DEFAULT nColor := 123123128 // LoadIni("MADRE","DegraDialog")

    IF !Empty( oBmp )
        IF UPPER(oWnd:ClassName()) == 'TDIALOG' // Si es un Dialogo
            oWnd:GetDC()
            PalBmpDraw( oWnd:hDC, 0, 0, oBmp:hBitmap )
            oWnd:ReleaseDC()
        ENDIF
        WndCenter( oBmp:hWnd, oWnd:hWnd )
    ENDIF

    If lPuro == .T.
        oWnd:SetColor( 0, nColor )
        oWnd:Refresh()
     Else
        lPuro := .F.
    Endif

    If !lPuro // El color no es puro, entonces degradado

       nBlue  := nRGBBlue( nColor )
       nRed   := nRGBRed( nColor )
       nGreen := nRGBGreen( nColor)

       DEFAULT nSaltos := 3

       nSteps := ( aRect[ 3 ] - aRect[ 1 ] ) / nSaltos

       oWnd:GetDC()

       aRect[ 3 ] = 0

       For N = 1 to nSteps

           aRect[ 3 ] += nSaltos

           DEFINE BRUSH oBrush COLOR RGB( nRed, nGreen, nBlue )

           FillRect( oWnd:hDC, aRect, oBrush:hBrush )

           RELEASE BRUSH oBrush

           aRect[ 1 ] += nSaltos

           nBlue -= 1
           nRed -= 1
           nGreen -= 1

           If nBlue  < 0 ; nBlue  += 1 ; Endif
           If nRed   < 0 ; nRed   += 1 ; Endif
           If nGreen < 0 ; nGreen += 1 ; Endif

        Next N

        oWnd:ReleaseDC()
        //oWnd:Refresh() // Liguei aqui, estava desligado

    Endif


Return Nil

//----------Fim da Rotina Para Colocar Cor No cabealho do Folder------------//

// VERIFICAR SE EXISTE UMA FONTE

FUNCTION CheckFont( oPrint, cFuente )

    Local aFont := {}, lExiste := .F.

    EnumFontFamilies( oPrint:hDC, cFuente, ;
    { | aLogFont, aPhyFont, nType |        ;
    aAdd( aFont, {aLogFont[ 14 ], Len( aPhyFont ), nType}) } )

    If Len(afont) > 0
        lExiste := .T.
    Endif

RETURN lExiste

//---------------------------------------------------------------------------//

// SELECIONAR TAMANHOO DA FOLHA EM TPRINTER() // Impressora.
/*
Voce Pode Fazer Desta Maneira:

oPrn:SetPage( nPage )

Onde nPage  um Nmero Que Indica O Tamanho da Folha da Impressora.

Te podes guiar com esta tabela:

1 // Letter 8 1/2 x 11 in
2 // Letter Small 8 1/2 x 11 in
3 // Tabloid 11 x 17 in
4 // Ledger 17 x 11 in
5 // Legal 8 1/2 x 14 in
6 // Statement 5 1/2 x 8 1/2 in
7 // Executive 7 1/4 x 10 1/2 in
8 // A3 297 x 420 mm
9 // A4 210 x 297 mm
10 // A4 Small 210 x 297 mm
11 // A5 148 x 210 mm
12 // B4 250 x 354
13 // B5 182 x 257 mm
14 // Folio 8 1/2 x 13 in
15 // Quarto 215 x 275 mm
16 // 10x14 in
17 // 11x17 in
18 // Note 8 1/2 x 11 in
19 // Envelope #9 3 7/8 x 8 7/8
20 // Envelope #10 4 1/8 x 9 1/2
*/

/*
segunda opcao 
preciso criar um arquivo txt sem caracter de fim de pagina.

usando append from sdf

eu sei fazer ao contrario.... pegar de um txt e jogar para o dbf... mas como fazer de um dbf.. passar para arq.txt ???


please
 
evandro 
Membro Avanado 
 

--------------------------------------------------------------------------------
Ol,
Simples: copy field campo1, campo2 to arq.txt sdf


[]s,

Evandro G. de Paula
Curvelo - MG
evandro@skillnet.com.br (Escr. - na Cidade)
imortal@skillnet.com.br (Res. - na Roa)
 
personal 
Membro Avanado 
 

    
--------------------------------------------------------------------------------
Esperimenta Set Printer to "arquivo.txt"


Oliveira, Srgio A.
PERSONAL - LINS
pcspersonal@pop.com.br
MSN - sergio@personal.com.br
*/

/*
 *	SPN.PRG
 *
 *	cShortName() - FilePath Long to Short (GetShortPathNameA())
 *
 *	Soporte a Funciones del Api de Windows
 *
 *	Andrade A. Daniel - 2002
 *	Rosario, Argentina
 *
 *	Libre Distribucin
 */

/*
# include "FiveWin.ch"

# ifdef TEST
FUNCTION Test()

    Local cFile := cGetFile32( "*.*", "Elija...",, "C:\", .F.,, )

    ? cFile, cShortName( cFile ), cShortName( cFilePath( cFile ) )

RETURN NIL
# endif

/*
 *	cShortName()
 */
FUNCTION cShortName( cLong )

    Local   cShort  := Space(164) + Chr(0)
    Local   nBuffer := 164
    Local   nLen

    nLen    := GetSPName( cLong, @cShort, nBuffer )

    cShort  := Left( cShort, nLen )

RETURN cShort

// Windows Api
DLL32 STATIC FUNCTION GetSPName( lpszLongPath AS STRING, lpszShortPath AS STRING, lBuffer AS LONG ) ;
      AS LONG PASCAL FROM "GetShortPathNameA" LIB "kernel32"
*/

/*----------------------------------------------------------------------------

  ChangePwd()
  <Wraper> al API MPR.DLL o cambiando la contrasea de Windows
  (C) 2001 Joaquim Ferrer Godoy
  http://www.getex.net/gentefive   gentefive@getex.net

*---------------------------------------------------------------------------*/
/*
Function Main()

    If MsgYesNo( "Desea cambiar la contrasea de Windows ?", "Aviso !" )
        ChangePwd()
    Endif

Return( 0 )

/*-------------------------------------------------------------------------*/

/*
Function ChangePwd( lpcRegkeyname )

    Local cFarProc, hDLL := LoadLib32( "MPR.DLL" ), hWnd := GetActiveWindow()

    cFarProc := GetProc32( hDLL, "PwdChangePasswordA",.T., ;
                           LONG, STRING, LONG, LONG, LONG )

    CallDLL32( cFarProc, lpcRegkeyname, hWnd, 0, 0 )

    FreeLib32( hDLL )

Return( 0 )
*/

/*-------------------------------------------------------------------------*/

//
// Compilar
// clipper demo
// rtlink fi demo
//
// A propria funcao coloca a picture de acordo com a UF e valida o numero
//

/*
#Include "inkey.ch"   // Esta Parte  para Clipper em DOS.

//M->ie := Space( 20 )
//M->uf := Space( 02 )

//Clear

//@ 10,10 Say "UF: " Get M->uf Picture "!!"
//@ 11,10 Say "IE: " Get M->ie When pic_iest()     Valid pic_iest( M->uf )
//Read

//Inkey( 0 )
*/

/*  // Esta Parte  Para FiveWin, Declarar as Variaveis 08/04/2004 - Joo.
//---------------------Checar a Inscrio Estadual----------------------------

Function Pic_Iest // Picture Inscrio Estadual, Validao.

Parameters cEstado, cInscricaoEstadual

Local GetList := {}, Ok := .F., Base, Vpos, Valg, Vsom, Vres, Vdig1, Vdig2,;
      Vpro, P, D, N, Vbase2, Origem

Vbase2 := Base := Origem := ""

If Pcount() == 2 .And. GetActive() == Nil

   For i := 1 To Len( Trim( cInscricaoEstadual ) )

       If Asc( Subs( cInscricaoEstadual, i, 1 ) ) < 48 .Or. ;
          Asc( Subs( cInscricaoEstadual, i, 1 ) ) > 57

          Return( cInscricaoEstadual )

       EndIf

   Next

   If Len( Alltrim( cInscricaoEstadual ) ) == 7

      Return( "@R PR 999/9999" )

   EndIf

   Do Case

      Case cEstado == "MT"

           Return( "@R 9999999999-9" )

      Case cEstado == "DF"

           Return( "@R 999.99999.999-99" )

      Case cEstado == "AC"

           Return( "@R 99.99.9999-9" )

      Case cEstado == "AL" .Or.;
           cEstado == "AP" .Or.;
           cEstado == "GO" .Or.;
           cEstado == "MA" .Or.;
           cEstado == "MS" .Or.;
           cEstado == "PI" .Or.;
           cEstado == "PB" .Or.;
           cEstado == "AM" .Or.;
           cEstado == "RO"

           Return( "@R 99.999.999-9" )

      Case cEstado == "CE" .Or.;
           cEstado == "RR" .Or.;
           cEstado == "SE"

           Return( "@R 99999999-9" )

      Case cEstado == "MG"

           Return( "@R 999.999.999/9999" )

      Case cEstado == "PA"

           Return( "@R 99-999999-9" )

      Case cEstado == "RJ"

           Return( "@R 99.999.99-9" )

      Case cEstado == "BA"

           Return( "@R 999999-99" )

      Case cEstado == "SC"

           Return( "@R 999.999.999" )

      Case cEstado == "SP"

           Return( "@R 999.999.999.999" )

      Case cEstado == "RS"

           Return( "@R 999/999999-9" )

      Case cEstado == "ES"

           Return( "@R 999.999.99-9" )

      Case cEstado == "TO"

           Return( "@R 99.99.999999-9" )

      Case cEstado == "PE"

           Return( "@R 99.9.999.9999999-9" )

      Case cEstado == "PR"

           Return( "@R 999.99999-99" )

      Case cEstado == "RN"

           Return( "@R 999.999.99-9" )

      Otherwise

           Return( Space(0) )

   EndCase

EndIf

oGet := GetActive()

If ( Pcount() == 0 )

   @ oGet:Row(),oGet:Col() Say Space( 17 )

   oGet:VarPut( IIf( Trim( oGet:VarGet() ) == "ISENTO(A)", ;
              Space(15), oGet:VarGet()+Space( 15-Len( oGet:VarGet() ) ) ) )

   oGet:Picture := "@!"

   Return( .T. )

EndIf

If Empty( oGet:VarGet() )

   oGet:VarPut( "ISENTO(A)" )

   oGet:Picture := "@!"

   @ oGet:Row(), oGet:Col() SAY SPACE(17)

   Return( .T. )

EndIf

cInscricaoEstadual := oGet:VarGet()

For Vpos := 1 To Len( Alltrim( cInscricaoEstadual ) )

    If SubStr( cInscricaoEstadual, Vpos, 1 ) $ "0123456789" .Or.;
       SubStr( cInscricaoEstadual, Vpos, 1 ) == "P" .And. cEstado == "SP"

       Origem += SubStr( cInscricaoEstadual, Vpos, 1 )

    EndIf

Next

Mascara := "99999999999999"

If cEstado == "AC"

   Mascara := "@R 99.99.9999-9"
   Base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "01" .And. SubStr( Base, 3, 2 ) <> "00"

      Vsom := 0

      For Vpos := 1 To 8

          Valg := Val( SubStr( Base, Vpos, 1 ) )
          Valg := Valg * ( 10 - Vpos )
          Vsom += Valg

      Next

      Vres   := Vsom % 11
      Vdig1  := Str( If( Vres < 2, 0, 11 - Vres ), 1, 0 )
      Vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "AL"

   Mascara := "@R 99.999.999-9"
   Base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "24"

      Vsom := 0

      For Vpos := 1 To 8

         Valg := Val( SubStr( Base, Vpos, 1 ) )
         Valg := Valg * ( 10 - Vpos )
         Vsom += Valg

      Next

      Vpro   := Vsom*10
      Vres   := Vpro%11
      Vdig1  := If( Vres == 10, "0", Str( Vres, 1, 0 ) )
      Vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem)

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "AM"

   Mascara := "@R 99.999.999-9"
   Base    := Padr( Origem, 9, "0" )
   Vsom    := 0

   For Vpos := 1 to 8

      Valg := Val( SubStr( Base, Vpos, 1 ) )
      Valg := Valg * ( 10 - Vpos )
      Vsom += Valg

   Next

   If Vsom < 11

      Vdig1 := Str( 11 - Vsom, 1, 0 )

   Else

      Vres  := Vsom%11
      Vdig1 := If( Vres < 2, "0", Str( 11 - Vres, 1, 0 ) )

   EndIf

   Vbase2 := Left( Base, 8 ) + Vdig1
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "AP"

   Mascara := "@R 99.999.999-9"
   Base    := Padr( origem, 9, "0" )

   If Left( Base, 2 ) == "03"

      N := Val( Left( Base, 8 ) )

      If N >= 3000001 .And. N <= 3017000

         P := 5
         D := 0

      ElseIf N >= 3017001 .And. N <= 3019022

         P := 9
         D := 1

      ElseIf N >= 3019023

         P := 0
         D := 0

      EndIf

      Vsom := P

      For Vpos := 1 To 8

        Valg := Val( SubStr( Base, Vpos, 1 ) )
        Valg := Valg * ( 10 - Vpos )
        Vsom += Valg

      Next

      Vres  := Vsom%11
      Vdig1 := 11-Vres

      If Vdig1 == 10

         Vdig1 := 0

      ElseIf Vdig1 == 11

         Vdig1 := D

      EndIf

      Vdig1  := Str( Vdig1, 1, 0 )
      Vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "BA"

   Mascara := "@R 999999-99"
   Base    := Padr( Origem, 8, "0" )

   If Left( Base, 1) $ "0123458"

      Vsom := 0

      For Vpos := 1 To 6

          Valg := Val( SubStr( Base, Vpos, 1 ) )
          Valg := Valg * ( 8 - Vpos )
          Vsom += Valg

      Next

      Vres   := Vsom%10
      Vdig2  := Str( If( Vres == 0, 0, 10 - Vres ), 1, 0 )
      Vbase2 := Left( Base, 6 ) + Vdig2
      Vsom   := 0

      For Vpos := 1 To 7

         Valg := Val( SubStr( Vbase2, Vpos, 1 ) )
         Valg := Valg*( 9 - Vpos )
         Vsom += Valg

      Next

      Vres  := Vsom%10
      Vdig1 := Str( If( Vres == 0, 0, 10-Vres ), 1, 0 )

   Else

      vsom:=0

      For Vpos :=1 to 6

          Valg := Val( SubStr( Base, Vpos, 1 ) )
          Valg := Valg*( 8 - Vpos )
          Vsom += Valg

      Next

      Vres   := Vsom%11
      Vdig2  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
      Vbase2 := Left( Base, 6 ) + Vdig2
      Vsom   := 0

      For Vpos := 1 To 7

          Valg := Val( SubStr( Vbase2, Vpos, 1 ) )
          Valg := Valg*( 9 - Vpos )
          Vsom += Valg

      Next

      Vres  := Vsom%11
      Vdig1 := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )

   EndIf

   vbase2 := Left( Base, 6 ) + Vdig1 + Vdig2
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "CE"

   mascara := "@R 99999999-9"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For vpos:=1 to 8

       Valg := Val( SubStr( Base, Vpos, 1 ) )
       Valg := Valg*( 10 - Vpos )
       Vsom += Valg

   Next

   Vres  := Vsom%11
   Vdig1 := 11-Vres

   if Vdig1 > 9

      Vdig1 := 0

   EndIf

   Vbase2 := Left( Base, 8 ) + Str( Vdig1, 1, 0 )
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "DF"

   mascara := "@R 999.99999.999-99"
   base    := Padr( Origem, 13, "0" )

   If Left( Base, 3 ) == "073"

      Vsom := 0
      Vmul := {4,3,2,9,8,7,6,5,4,3,2}

      For Vpos := 1 To 11

          valg := Val( SubStr( Base, Vpos, 1 ) )
          valg := Valg * vmul[vpos]
          vsom += Valg

      Next

      vres   := vsom%11
      vdig1  := If( Vres < 2, 0, 11-Vres )
      vbase2 := Left( Base, 11 ) + Str( Vdig1, 1, 0 )
      vsom   := 0
      vmul   := {5,4,3,2,9,8,7,6,5,4,3,2}

      For vpos:=1 to 12

        valg := Val( Substr( Vbase2, Vpos, 1 ) )
        valg := Valg * Vmul[Vpos]
        vsom += Valg

      Next

      vres   := Vsom%11
      vdig2  := If( Vres < 2, 0, 11-Vres )
      vbase2 += Str( Vdig2, 1, 0 )
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "ES"

   mascara := "@R 999.999.99-9"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For vpos:=1 to 8

      Valg := Val( SubStr( Base, Vpos, 1 ) )
      Valg := Valg * ( 10 - Vpos )
      Vsom += Valg

   Next

   Vres   := Vsom%11
   Vdig1  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
   Vbase2 := Left( Base, 8) + Vdig1
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "GO"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) $ "10,11,15"

      Vsom := 0

      For Vpos := 1 To 8

         valg := Val( SubStr( Base, Vpos, 1 ) )
         valg := Valg * ( 10 - Vpos )
         vsom += Valg

      Next

      Vres := Vsom%11

      If vres == 0

         vdig1 := "0"

      ElseIf Vres == 1

         n     := Val(left(base,8))
         vdig1 := If( N >= 10103105 .And. N <= 10119997, "1", "0" )

      Else

         vdig1:=str(11-vres,1,0)

      EndIf

      vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "MA"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "12"

      Vsom := 0

      for vpos:=1 to 8
          valg:=val(substr(base,vpos,1))
          valg:=valg*(10-vpos)
          vsom+=valg
      next

      vres   := vsom%11
      vdig1  := Str( If( Vres < 2, 0, 11 - Vres ), 1, 0 )
      vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "MT"

   mascara := "@R 9999999999-9"
   vmul    := {3,2,9,8,7,6,5,4,3,2}

   For Vpos := 1 To 10

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := Valg * Vmul[Vpos]
      vsom += Valg

   Next

   vres   := vsom%11
   vdig1  := If( Vres < 2, 0, 11 - Vres )
   vbase2 := Left( Base, 10 ) + Str( Vdig1, 1, 0 )
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "MS"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "28"

      vsom := 0

      For vpos:=1 to 8

         valg := Val( SubStr( Base, Vpos, 1 ) )
         valg := Valg*(10-vpos)
         vsom += Valg

      Next

      vres   := vsom%11
      vdig1  := Str( If( vres < 2, 0, 11-Vres ), 1, 0 )
      vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "MG"

   mascara := "@R 999.999.999/9999"
   base    := Padr( Origem, 13, "0" )
   vbase2  := Left( Base, 3 ) + "0" + SubStr( Base, 4, 8 )
   n       := 2
   vsom    := ""

   For Vpos := 1 To 12

       valg := Val( SubStr( vbase2, vpos, 1 ) )
       n    := If( N==2, 1, 2 )
       valg := Alltrim( Str( Valg * N, 2, 0 ) )
       vsom += VAlg

   Next

   n := 0

   For Vpos := 1 To Len(Vsom)

     n += Val( SubStr( Vsom, Vpos, 1 ) )

   Next

   Vsom := N

   While Right( Str( n, 3, 0), 1 ) <> "0"

     N++

   End

   Vdig1  := Str( N-Vsom, 1, 0 )
   Vbase2 := Left( Base, 11 ) + Vdig1
   Vsom   := 0
   Vmul   := {3,2,11,10,9,8,7,6,5,4,3,2}

   For Vpos := 1 To 12

      valg := Val( SubStr( Vbase2, vpos, 1 ))
      valg := Valg * Vmul[Vpos]
      vsom += Valg

   Next

   vres   := Vsom%11
   vdig2  := If( Vres < 2, 0, 11-Vres )
   vbase2 += Str( vdig2, 1, 0 )
   Ok     := ( vbase2 == origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "PA"

   Mascara := "@R 99-999999-9"
   Base    := padr(origem,9,"0")

   If Left( base, 2 ) == "15"

      vsom := 0

      For vpos := 1 to 8

        valg := Val( Substr( Base, Vpos, 1 ) )
        valg := Valg * ( 10 - Vpos )
        vsom += Valg

      Next

      Vres   := Vsom%11
      Vdig1  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
      Vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == origem)

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "PB"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For vpos:=1 to 8

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := Valg * ( 10 - Vpos )
      vsom += Valg

   Next

   Vres   := vsom%11
   vdig1  := 11-vres

   If Vdig1 > 9

      vdig1 := 0

   EndIf

   vbase2 := Left( Base, 8 ) + Str( Vdig1, 1, 0 )
   Ok     := ( vbase2 == origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "PE"

   mascara := "@R 99.9.999.9999999-9"
   base    := Padr( Origem, 14, "0" )
   vsom    := 0
   vmul    := {5,4,3,2,1,9,8,7,6,5,4,3,2}

   For Vpos := 1 To 13

     valg := Val( SubStr( Base, Vpos, 1 ) )
     valg := Valg * Vmul[Vpos]
     vsom += Valg

   Next

   vres  := Vsom%11
   vdig1 := 11-Vres

   if( Vdig1 > 9, Vdig1 -= 10, )

   Vbase2 := Left( Base, 13 ) + Str( Vdig1, 1, 0 )
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "PI"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For vpos := 1 to 8

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := Valg * ( 10-Vpos )
      vsom += Valg

   Next

   Vres   := vsom%11
   Vdig1  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
   Vbase2 := Left( Base, 8 ) + Vdig1
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "PR"

   mascara := "@R 999.99999-99"
   base    := Padr( Origem, 10, "0" )
   vsom    := 0
   vmul    := {3,2,7,6,5,4,3,2}

   For Vpos :=1 to 8

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := Valg * Vmul[Vpos]
      vsom += Valg

   Next

   vres   := Vsom%11
   vdig1  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
   vbase2 := Left( Base, 8 ) + Vdig1
   vsom   := 0
   vmul   := {4,3,2,7,6,5,4,3,2}

   For Vpos := 1 to 9

      valg := Val( SubStr( Vbase2, Vpos, 1 ) )
      valg := Valg*Vmul[Vpos]
      vsom += Valg

   next

   vres   := Vsom%11
   vdig2  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
   vbase2 += Vdig2
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "RJ"

   mascara := "@R 99.999.99-9"
   base    := Padr( Origem, 8, "0" )
   vsom    := 0
   vmul    := {2,7,6,5,4,3,2}

   For Vpos := 1 to 7

     valg := Val( SubStr( Base, Vpos, 1 ) )
     valg := Valg*Vmul[vpos]
     vsom += Valg

   Next

   vres   := Vsom%11
   vdig1  := Str( If( Vres < 2, 0, 11-Vres ), 1, 0 )
   vbase2 := Left( Base, 7 ) + Vdig1
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "RN"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "20"

      Vsom := 0

      For Vpos := 1 to 8

          valg := Val( SubStr( Base, Vpos, 1 ) )
          valg := Valg*(10-vpos)
          vsom += Valg

      Next

      vpro   := Vsom*10
      vres   := Vpro%11
      vdig1  := Str( If( Vres > 9, 0, Vres ), 1, 0 )
      vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "RO"

   mascara := "@R 99.999.999-9"
   base    := Padr( Origem, 9, "0" )
   vbase2  := SubStr( Base, 4, 5 )
   vsom    := 0

   For Vpos := 1 to 5

       valg := Val( SubStr( vbase2, vpos, 1 ) )
       valg := valg * ( 7 - Vpos )
       vsom += valg

   Next

   vres  := vsom%11
   vdig1 := 11 - Vres

   If Vdig1 > 9

      Vdig1 -= 10

   EndIf

   vbase2 := Left( Base, 8 ) + Str( vdig1, 1, 0 )
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "RR"

   mascara := "@R 99999999-9"
   base    := Padr( Origem, 9, "0" )

   If Left( Base, 2 ) == "24"

      vsom := 0

      For Vpos := 1 to 8

         Valg := Val( SubStr( Base, vpos, 1 ) )
         Valg := Valg * Vpos
         Vsom += Valg

      Next

      vres   := vsom%9
      vdig1  := Str( Vres, 1, 0 )
      vbase2 := Left( Base, 8 ) + Vdig1
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "RS"

   mascara := "@R 999/999999-9"
   base    := Padr( Origem, 10, "0" )
   n       := Val( Left( Base, 3 ) )

   If N > 0 .And. n < 468

      vsom := 0
      vmul := {2,9,8,7,6,5,4,3,2}

      For Vpos := 1 to 9

         valg := Val( SubStr( Base, Vpos, 1 ) )
         valg := Valg * Vmul[vpos]
         vsom += Valg

      Next

      vres  := vsom%11
      vdig1 := 11-vres

      If Vdig1 > 9

         Vdig1 := 0

      EndIf

      vbase2 := Left( Base, 9 ) + Str( Vdig1, 1, 0 )
      Ok     := ( Vbase2 == Origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "SC"

   mascara := "@R 999.999.999"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For Vpos := 1 to 8

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := Valg * ( 10 - Vpos )
      vsom += Valg

   Next

   vres   := Vsom%11
   vdig1  := If( Vres < 2, "0", Str( 11-vres, 1, 0 ))
   vbase2 := Left( Base, 8 ) + Vdig1
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "SE"

   mascara := "@R 99999999-9"
   base    := Padr( Origem, 9, "0" )
   vsom    := 0

   For Vpos := 1 to 8

      valg := Val( SubStr( Base, Vpos, 1 ) )
      valg := valg * ( 10 - vpos )
      vsom += valg

   Next

   vres  := vsom%11
   vdig1 := 11-vres

   If vdig1 > 9

      Vdig1 := 0

   EndIf

   vbase2 := Left( Base, 8 ) + Str( vdig1, 1, 0 )
   Ok     := ( Vbase2 == Origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "SP"

   If Left( Origem, 1 ) == "P"

      mascara := "@R !-99999999.9/999"
      base    := Padr( origem, 13, "0" )
      vbase2  := SubStr( Base, 2, 8 )
      vsom    := 0
      vmul    := {1,3,4,5,6,7,8,10}

      For Vpos := 1 to 8

        valg := Val( SubStr( Vbase2, Vpos, 1 ) )
        valg := Valg * Vmul[vpos]
        vsom += Valg

      Next

      Vres   := Vsom%11
      Vdig1  := Right( Str( Vres, 2, 0 ), 1 )
      Vbase2 := Left( Base, 9 ) + Vdig1 + SubStr( Base, 11, 3 )

   Else

      mascara := "@R 999.999.999.999"
      base    := Padr( Origem, 12, "0" )
      vsom    := 0
      vmul    := {1,3,4,5,6,7,8,10}

      For Vpos := 1 To 8

         valg := Val( SubStr( Base, vpos, 1 ) )
         valg := valg * vmul[vpos]
         vsom += valg

      Next

      vres   := vsom%11
      vdig1  := Right( Str( vres, 2, 0 ), 1 )
      vbase2 := Left( Base, 8 ) + Vdig1 + SubStr( Base, 10, 2 )
      vsom   := 0
      vmul   := {3,2,10,9,8,7,6,5,4,3,2}

      For Vpos := 1 to 11

         valg := Val( SubStr( Base, vpos, 1 ) )
         valg := valg * vmul[vpos]
         vsom += valg

      Next

      vres   := vsom%11
      vdig2  := Right( Str( vres, 2, 0 ), 1 )
      vbase2 += vdig2

   EndIf

   Ok := ( vbase2 == origem )

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

ElseIf cEstado == "TO"

   mascara := "@R 99.99.999999-9"
   base    := Padr( Origem, 11, "0" )

   If SubStr( Base, 3, 2 ) $ "01,02,03,99"

      vbase2 := Left( Base, 2 ) + SubStr( Base, 5, 6 )
      vsom   := 0

      For Vpos := 1 to 8

         valg := Val( SubStr( vbase2, vpos, 1 ) )
         valg := valg * ( 10 - vpos )
         vsom += valg

      Next

      Vres   := vsom%11
      Vdig1  := Str( If( vres < 2, 0, 11 - Vres ), 1, 0 )
      Vbase2 := Left( Base, 10 ) + vdig1
      Ok     := ( vbase2 == origem )

   EndIf

   If Ok

      oGet:VarPut( vbase2 )

      oGet:Picture := mascara

   EndIf

Else

   Alert( "Unidade Federativa Invalida !" )

EndIf

If !Ok .And. LastKey() # K_UP

   If Empty( vbase2 )

      Alert( "Os Dgitos Identificadores de Cidade e/ou Estado No Conferem !" )

   Else

      vbase2 := TransForm( Alltrim( vbase2 ), mascara )

      Alert( "Inscrio Invlida! O Correto Seria " + Vbase2 )

   EndIf

   Return( .F. )

EndIf

If Len( Alltrim( oGet:VarGet() ) ) == 7

   oGet:VarPut( Alltrim( oGet:VarGet() ) )

   oGet:Picture := "@R PR 999/9999"

EndIf

@ oGet:Row(), oGet:Col() SAY Space( 17 )

Return( .T. )
*/

//----------------------------------------------------------------------------//
//-> PROTEO DE TELA DO SISTEMA, CHAMA O DAZZLE.EXE FOR WINDOWS

FUNCTION PROTTELA()

    LOCAL Nome_Arq, nRegistro

    IF !FILE( ".\DAZZLE.EXE" )

        SndPlaySound(".\Erro.Wav" )
        MsgAlert( "O Arquivo " + "DAZZLE.EXE "                    +           ;
                  "No Foi Encontrado"                            + CRLF +    ;
                  "Entre em Contato Com a Comparies Tecnologia"   + CRLF +    ;
                  "Pelos Fones: (11) 5681-4569 / 5681-4828    "   + CRLF +    ;
                  "e Pea Para Ser Enviado Para Voc.         ",              ;
                  "Componente Ausente, Verifique!" )
        RETURN NIL
    ENDIF

    IF IsWinNT() .OR. IsWin2000()  // Para Windows XP/NT e 2000 / 2003
        // Vai Chamar a Bat do Descanso de Tela
        WinExec( "DAZZLE.EXE /W" )
        RETURN NIL
     ELSE
        // Cria o Arquivo de Lote Backup.Bat no Diretrio, Com as Diretrizes.
        IF !FILE( "DAZZLE.BAT" )

            NOME_ARQ := FCREATE("DAZZLE.BAT")

            NREGISTRO := "@ECHO OFF"                                          ;
                         + CRLF +                                             ;
                         "CLS"                                                ;
                         + CRLF + CRLF +                                      ;
                         "DAZZLE.EXE /W"                                      ;
                         + CRLF + CRLF +                                      ;
                         "CLS"                                                ;
                         + CRLF +                                             ;
                         "EXIT"

            FWRITE( NOME_ARQ, NREGISTRO )
            FCLOSE( NOME_ARQ )

        ENDIF

        // Vai Chamar a Bat do Descanso de Tela
        WinExec( "DAZZLE.BAT", 0 )

    ENDIF

RETURN NIL

//-> Checar a Resoluo do Vdeo, Pois No  Permitido < 800 x 600

FUNCTION CHECA_RESOLUCAO()

    LOCAL ARES

    aRes := ScrResolution()

    IF ARES[1]<800

        SndPlaySound(".\Erro.wav" )
        MsgInfo( "Detectado Que Este Ambiente Est Configurado  " + CRLF +    ;
                 "Para Ser Executado Com Resoluo de Tela Igual" + CRLF +    ;
                 "a 640 x 480, Este Programa, Somente Trabalha, " + CRLF +    ;
                 "Com Resoluo 800 x 600 ou Superior.          " + CRLF +    ;
                 "AJUSTE O SEU VIDEO, E TENTE NOVAMENTE.        " + CRLF +    ;
                 "Comparies Tecnologia - (11) 5681-4569  Edvaldo",            ;
                 "Erro Na Resoluo do Vdeo" )

        DbCloseAll()
        __Quit()

    ENDIF

RETURN NIL

//---------------------------------------------------------------------------//

FUNCTION TRAVEREG(TEMPO)

    DO WHILE .NOT. REGLOCK(TEMPO)

        MSGWAIT("AGUARDE ACESSO ARQUIVO","Bloqueando o registro...Aguarde",01)

    ENDDO

RETURN(0)

FUNCTION ADICIONE(TEMPO)

    DO WHILE .NOT. ADIREG(TEMPO)

        MSGWAIT("AGUARDE ACESSO ARQUIVO","Adio de novo registro...Aguarde",01)

    ENDDO

RETURN(0)

FUNCTION ADIREG(TEMPO)

    * RETORNA VERDADEIRA SE O REGISTRO FOI APENDADO.O NOVO REG.PASSA A SER O REG.ATUAL BLOQUEADO
    * PAR: 1-NUMERICO-TEMPO DE ESPERA

    LOCAL SEMPRE, TELA

    APPEND BLANK

    IF .NOT. NETERR()
        TRAVEREG(0)
        RETURN(.T.)
    ENDIF

    SEMPRE=(TEMPO=0)

    DO WHILE( SEMPRE .OR. TEMPO > 0 ) .AND. INKEY() <> 27

        APPEND BLANK

        IF .NOT. NETERR()
            TRAVEREG(0)
            RETURN(.T.)
        ENDIF

        SYSWAIT(.5)
        TEMPO=TEMPO-.5

    ENDDO

RETURN( .F. )  && NAO BLOQUEADO

FUNCTION REGLOCK(TEMPO)

    * TENTA TRAVAR O REGISTRO ATUAL
    *PAR: 1-NUMERICO-TEMPO ESPERA

    LOCAL SEMPRE, TELA

    IF RLOCK()

      RETURN(.T.)  && BLOQUEADO

    ENDIF

    SEMPRE=(TEMPO=0)

    DO WHILE (SEMPRE .OR. TEMPO > 0 ) .AND. INKEY() <> 27

        IF RLOCK()
            RETURN(.T.)   && BLOQUEADO
        ENDIF

        SYSWAIT( .5 )

        TEMPO=TEMPO-.5

    ENDDO

RETURN( .F. )    && NAO BLOQUEADO

FUNCTION DESTRAVA()

    COMMIT
    UNLOCK

RETURN(NIL)

*-------------------------------------------------------------------------
*     Mensagem de Sada do Sistema
*-------------------------------------------------------------------------
FUNCTION __ExitMsg()

   LOCAL oDlg, oYes, oNo
   LOCAL lRet := .T.,oFont

   DEFINE FONT oFont  NAME 'Arial' SIZE 0, -22

   DEFINE DIALOG oDlg RESOURCE "EXITMSG"

   oDlg:lhelpicon := .F.

   REDEFINE SAY ID 901 OF oDlg FONT oFont

   REDEFINE Button oYes ID 151 OF oDlg ;
            ACTION ( oDlg:END() )

   REDEFINE Button oNo  ID 152 OF oDlg ;
            ACTION ( lRet := .F., oDlg:End() ) CANCEL

   ACTIVATE DIALOG oDlg CENTER

   oFont:End()

RETURN ( lRet )

//---------------------------------------------------------------------------//

// FIM DO PROGRAMA
