*=========================================================================
*   Programa.....: FUNCOES - Funes Gerais
*   Data.........: 09/2004
*   Autor........: Vimatec Sistemas
*   Titulo.......: Funes Gerais
*=========================================================================
#Include 'FiveWin.ch'
*-------------------------------------------------------------------------
*     Mensagem de Sada do Sistema
*-------------------------------------------------------------------------
FUNCTION __ExitMsg()

   LOCAL oDlg, oYes, oNo
   LOCAL lRet := .T.,oFont

   DEFINE FONT oFont  NAME 'Arial' SIZE 0, -22

   DEFINE DIALOG oDlg RESOURCE "EXITMSG"

   oDlg:lhelpicon := .F.

   REDEFINE SAY ID 901 OF oDlg FONT oFont

   REDEFINE Button oYes ID 151 OF oDlg ;
            ACTION ( oDlg:END() )

   REDEFINE Button oNo  ID 152 OF oDlg ;
            ACTION ( lRet := .F., oDlg:End() ) CANCEL

   ACTIVATE DIALOG oDlg CENTER

   oFont:End()

RETURN ( lRet )

*-------------------------------------------------------------------------
*     Abre arquivo de forma exclusiva para indexao
*-------------------------------------------------------------------------
Function S_ABRIR(cArq)

   IF !file(cArq)
      MsgAlert('Arquivo '+cArq+' no encontrado. Verifique.',"Erro na abertura do arquivo")
      RETURN(.F.)
   ENDIF

   USE (cArq) NEW EXCLUSIVE

   IF ( NetErr() )
      MsgAlert('Arquivo '+wInd+' no pode ser aberto em modo exclusivo pois algum usurio est usando este arquivo. Tente mais tarde.',"Erro na abertura do arquivo")
      CLOSE DATABASES
      RETURN(.F.)
   ENDIF

RETURN(.t.)

*---------------------------------------------------------------------
*     Abre Arquivo
* cArq = Arquivo
* cTipo= C Compartilhado
*        E Exclusivo
* oDBF = Objeto do DBF
*-------------------------------------------------------------------------
Function S_ABRE(cArq,cTipo,oDBF)

   LOCAL wInd,lUseMode
   wInd:= At(".",cArq)
   wInd:= SubStr(cArq,1,wInd-1)

   IF !file(cArq)
      MsgAlert('Arquivo '+wInd+' no encontrado. Avise o administrador do sistema.',"Erro na abertura do arquivo")
      CLOSE DATABASES
      RETURN(.F.)
   ENDIF

   IF cTipo = "C" ; lUseMode:=.T. ; ELSE ; lUseMode:= .F. ; ENDIF

   oDBF := DbfSetArea( .T., , cArq, lUseMode )
   IF ( oDBF == -1 )
      MsgStop( "All work areas are being used, Please close some windows and try again.", "Open Database Error" )
      RETURN(.F.)
   ENDIF
//   IF cTipo = "C"
//      USE (cArq) NEW SHARED
//   ELSE
//      USE (cArq) NEW EXCLUSIVE
//   ENDIF

   IF ( NetErr() )
      IF cTipo = "C"
         MsgAlert('Arquivo '+wInd+' no pode ser aberto pois est em modo exclusivo. Tente mais tarde.',"Erro na abertura do arquivo")
      ELSE
         MsgAlert('Arquivo '+wInd+' no pode ser aberto em modo exclusivo pois algum usurio est usando este arquivo. Tente mais tarde.',"Erro na abertura do arquivo")
      ENDIF
      CLOSE DATABASES
      RETURN(.F.)
   ENDIF

   DataBase oDBF
   IF file(wind+".cdx")
      SET Index TO (wInd)
   ENDIF

RETURN(.t.)

STATIC FUNCTION DbfSetArea( lNew, cRDD, cDataFile, lUseMode )
   LOCAL nNextArea := 0, cAlias := ""

   nNextArea := DbfArea()

   IF ( nNextArea != -1 )
      cAlias := 3 - Len( Alltrim( Str( nNextArea ) ) )
      cAlias := Left( cFileName( cDataFile ), 5 ) + AllTrim( StrZero( nNextArea,2 ) )
      DbUseArea( lNew, cRDD, cDataFile, cAlias, lUseMode )
   ENDIF

RETURN ( nNextArea )

FUNCTION DbfArea()
   LOCAL lMore := .T.
   LOCAL n := 0

   WHILE ( ( lMore ) .AND. ( n < 255 ) )
      ++n
      IF ( Empty( Alias( n ) ) )
         lMore := .F.
      ENDIF
   END

RETURN ( IF( n == 255, -1, n ) )

*================================================================*
*  DbApndRec Function                                            *
*                                                                *
*  Suggested usage:                                              *
*  IF ! DbApndRec( lRelease )                                    *
*    ...           && Error-trapping code to exit the module.    *
*  ENDIF                                                         *
*  PARAMETER USED:                                               *
*    1. MODE (.T. = RELEASE CURRENT LOCKS .F. = NO RELEASE)      *
*================================================================*
FUNCTION DbApndRec( nDelay, lRelease )
LOCAL lRetVal := .F., nTries

IF ( lRelease == NIL )
   lRelease := .T.
ENDIF

IF ( nDelay == NIL )
   nDelay := 0
ENDIF

nTries := nDelay

WHILE .T.

   DbAppend( lRelease )

   IF ( !NetErr() )
      lRetVal := .T.
      EXIT
   ENDIF
   IF ( nTries > 0 )
      Inkey( 1 )
      nTries--
      LOOP
   ELSE
      IF ( LockWin( ProcName(), Alias() ) )
         nTries := nDelay
         LOOP
      ELSE
         EXIT
      ENDIF
   ENDIF
END
RETURN ( lRetVal )
*=====================================================================*
*  DbLockRec Function                                                 *
*                                                                     *
*  Example usage:                                                     *
*    IF DbLockRec( xIdentity )                                        *
*       ... Executing code                                            *
*    ELSE                                                             *
*       RETURN                                                        *
*    ENDIF                                                            *
*  PARAMETERS USED:                                                   *
*    1. xIdentity = Unique Record Identifier to                       *
*       specify particular record to lock. If omitted, current record *
*       will be added to the Lock List.                               *
*    In .DBF files xIdentity will be the record number (i.e. Recno()) *
*=====================================================================*
FUNCTION DbLockRec( nDelay, xIdentity )
LOCAL lRetVal := .F., nTries

IF ( nDelay == NIL )
   nDelay := 0
ENDIF

nTries := nDelay

WHILE .T.

   IF ( xIdentity == NIL )
       IF ( DbrLock() )
          lRetVal := .T.
          EXIT
       ENDIF
    ELSE
       IF ( DbrLock( xIdentity ) )
          lRetVal := .T.
          EXIT
       ENDIF
   ENDIF

   IF ( nTries > 0 )
      InKey( 1 )
      nTries--
      LOOP
   ELSE
      IF ( LockWin( ProcName(), Alias() ) )
         nTries := nDelay
         LOOP
      ELSE
         EXIT
      ENDIF
   ENDIF
END
RETURN ( lRetVal )
*==============================================*
*  LockWin() --> .T. ==> Retry                 *
*                .F. ==> Cancel                *
*==============================================*
STATIC FUNCTION LockWin( cProc, cDataFile )
LOCAL cTitle, cMessage

IF ( cProc == "DBAPNDREC" )
   cTitle   := "Incluso de um novo registro"
   cMessage := "Erro na incluso de um novo registro. Deseja tentar " + ;
               "novamente ?" + CRLF + ;
               "Arquivo: " + cDataFile
ELSEIF ( cProc == "DBLOCKREC" )
   cTitle   := "Erro no bloqueio do registro"
   cMessage := "Falha no bloqueio do registro. Deseja tentar " + ;
               "novamente ?" + CRLF + ;
               "Arquivo: " + cNoExt( cNoPath( cDataFile ) )
ENDIF

RETURN ( MsgStop( cMessage, cTitle ) )
*===============================================
* Funo.....: S_TITUL
* Autor......: Athenas Informatica.
* Data.......: Junho/99.
* Descrio..: Busca o titulo do mes.
*-------------------------------------------------------------
FUNCTION S_TITUL(SMES)
   LOCAL STITULO:= " "
   LOCAL TITULO[12]
   TITULO[01] = "  Janeiro"
   TITULO[02] = "Fevereiro"
   TITULO[03] = "    Maro"
   TITULO[04] = "    Abril"
   TITULO[05] = "     Maio"
   TITULO[06] = "    Junho"
   TITULO[07] = "    Julho"
   TITULO[08] = "   Agosto"
   TITULO[09] = " Setembro"
   TITULO[10] = "  Outubro"
   TITULO[11] = " Novembro"
   TITULO[12] = " Dezembro"
   STITULO = TITULO[SMES]
RETURN (STITULO)

*=========================================================================
* Valida campos da tela de dialogo quando teclado OK
*=========================================================================
Function Validacao(oDlg) //valida todos os gets da dialog passada

   Local lRet:=.t.,f:=1
   G_Teste = .F.

   While f<=Len(oDlg:aControls) //acontrols  uma propriedade de todas as dialogs e  criada automaticamente
     If oDlg:aControls[f]:lActive.and.ValType(oDlg:aControls[f]:bValid)=="B"
       If !Eval(oDlg:aControls[f]:bValid,oDlg:aControls[f])
         lRet:=.f.
       End
     End
     f++
   End
   G_Teste = .T.
   if !lRet
     MsgStop("Existem campos obrigatrios que no foram preenchidos"+chr(13)+"ou o valor do campo no  vlido."+chr(13)+"Corrija e tente novamente !!","Erro encontrado")
   End

Return(lRet)

*=========================================================================
* Confere Inscrio Estadual
*=========================================================================
Function S_InsCri(cInsCri,cEstado)

   local nRet := CON_INSC( cInsCri, cESTADO )

   IF nRet == 0
      Return(.T.)   && INSCRICAO  VALIDA
   ElseIF nRet == 1
      S_Mensa("Inscrio estadual invlida para o estado informado")   && INSCRICAO NAO E' VALIDA
      Return(.F.)
   Else
      S_Mensa("Parametros invlidos da inscr. estadual")       && ERRO DE ACESSO
      Return(.F.)
   Endif
Return(.T.)

*-------------------------------------------------------------------------
DLL32 function CON_INSC( INSC AS STRING, UF AS STRING ) AS LONG PASCAL ;
      from "ConsisteInscricaoEstadual" lib "DLLINSCE.DLL"
*=========================================================================
* Confere Data
*=========================================================================
Function S_CompDat(cCpoIni,cCpoFim)
   IF Empty(cCpoFim)
      MsgAlert("Final do intervalor deve estar preenchido.")
      Return(.F.)
   EndIF
   IF cCpoFim < cCpoIni
      MsgAlert("Final do intervalor no pode ser menor que o incio do intervalo.")
      Return(.F.)
   EndIF
Return(.T.)
*=========================================================================
